"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const Anchor = _ref => {
  let {
    block,
    children,
    disabled,
    external,
    href,
    loading,
    openInNewWindow,
    css,
    target,
    theme,
    styles,
    noHoverUnderline,
    ...props
  } = _ref;
  return !external && href ? /*#__PURE__*/_react.default.createElement(_reactRouterDom.Link, _extends({}, props, css(styles.anchor, !noHoverUnderline && styles.anchor_underlined), {
    to: href,
    disabled: disabled,
    target: openInNewWindow ? '_blank' : '_self'
  }), children) : /*#__PURE__*/_react.default.createElement("a", _extends({}, props, css(styles.anchor, !noHoverUnderline && styles.anchor_underlined), {
    href: href,
    target: target
  }), children);
};

const AnchorWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color
  } = _ref2;
  return {
    anchor: {
      color: color.secondary,
      cursor: 'pointer',
      textDecoration: 'none'
    },
    anchor_underlined: {
      ':hover': {
        textDecoration: 'underline'
      }
    }
  };
})(Anchor);
var _default = AnchorWithStyles;
exports.default = _default;