"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Autocomplete = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactOutsideClickHandler = _interopRequireDefault(require("react-outside-click-handler"));

var _Input = _interopRequireDefault(require("./Input"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const propTypes = {
  activeIndexOnInputChange: _propTypes.default.number,
  addClearInput: _propTypes.default.bool,
  autoFocus: _propTypes.default.bool,
  book: _propTypes.default.bool,
  clearOnSelect: _propTypes.default.bool,
  clearOnSubmit: _propTypes.default.bool,
  defaultActiveIndex: _propTypes.default.number,
  defaultValue: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  hideDropdownOnSubmit: _propTypes.default.bool,
  hideLabel: _propTypes.default.bool,
  hideResultsTopBorder: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  inputBorderless: _propTypes.default.bool,
  inputFocusBorderless: _propTypes.default.bool,
  inputOverflowEllipsis: _propTypes.default.bool,
  inputRef: _propTypes.default.func,
  inputRemoveMargins: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  label: _propTypes.default.string,
  labelDescription: _propTypes.default.string,
  large: _propTypes.default.bool,
  maxResults: _propTypes.default.number,
  name: _propTypes.default.string,
  noResultsLabel: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.symbol]),
  onBlur: _propTypes.default.func,
  onCancel: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  onSelect: _propTypes.default.func,
  onSubmit: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  prefix: _propTypes.default.symbol,
  results: _propTypes.default.arrayOf(_propTypes.default.object),
  resultsBorderless: _propTypes.default.bool,
  resultsMaxHeight: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  resultsPosition: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  resultsWidth: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  scrollResults: _propTypes.default.bool,
  showFakeValuePlaceholder: _propTypes.default.bool,
  small: _propTypes.default.bool,
  subResultPaddingUnits: _propTypes.default.number,
  underlineFocus: _propTypes.default.bool
};

class Autocomplete extends _react.Component {
  constructor(props) {
    super(props);
    this.state = {
      activeIndex: props.defaultActiveIndex || -1,
      areResultsVisible: false,
      lastEventType: null,
      value: ''
    };
  }

  render() {
    const {
      activeIndexOnInputChange,
      addClearInput,
      autoFocus,
      book,
      clearOnSelect,
      clearOnSubmit,
      defaultActiveIndex,
      defaultValue,
      disabled,
      hideDropdownOnSubmit,
      hideLabel,
      hideResultsTopBorder,
      id,
      inline,
      inputBorderless,
      inputFocusBorderless,
      inputOverflowEllipsis,
      inputRef,
      inputRemoveMargins,
      invalid,
      inverse,
      loading,
      label,
      labelDescription,
      large,
      maxResults,
      name,
      noResultsLabel,
      onBlur,
      onCancel,
      onChange,
      onFocus,
      onSelect,
      onSubmit,
      placeholder,
      prefix,
      results,
      resultsBorderless,
      resultsMaxHeight,
      resultsPosition,
      resultsWidth,
      scrollResults,
      showFakeValuePlaceholder,
      small,
      subResultPaddingUnits,
      underlineFocus
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_reactOutsideClickHandler.default, null, /*#__PURE__*/_react.default.createElement(_Input.default, {
      autoComplete: "off",
      autoFocus: autoFocus,
      book: book,
      borderless: inputBorderless,
      disabled: disabled //errorMessage={errorMessage}
      ,
      focusBorderless: inputFocusBorderless,
      hideLabel: hideLabel,
      id: id,
      inline: inline,
      inputRef: inputRef,
      invalid: invalid,
      inverse: inverse,
      label: label,
      labelDescription: labelDescription,
      large: large,
      name: name //onBlur={onBlur}
      //onChange={onChange}
      //onClear={onClear}
      //onFocus={onFocus}
      //onKeyDown={onKeyDown}
      ,
      placeholder: placeholder,
      prefix: prefix //refForFocus={refForFocus}
      ,
      removeMargins: inputRemoveMargins,
      showFakeValuePlaceholder: showFakeValuePlaceholder,
      showOverflowEllipsis: inputOverflowEllipsis,
      small: small,
      type: "text",
      underlineFocus: underlineFocus,
      value: this.state.value
    }));
  }

}

exports.Autocomplete = Autocomplete;
Autocomplete.propTypes = propTypes;