"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  inline: _propTypes.default.bool,
  large: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  small: _propTypes.default.bool,
  source: _propTypes.default.string,
  square: _propTypes.default.string,
  size: _propTypes.default.number
};

const Avatar = _ref => {
  let {
    css,
    inline,
    large,
    loading,
    micro,
    size,
    small,
    source,
    square,
    styles
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.avatar, inline && styles.avatar_inline, large && styles.avatar_large, micro && styles.avatar_micro, small && styles.avatar_small, square && styles.avatar_square, !micro && !small && !large && !size && styles.avatar_medium, {
    backgroundImage: "url(".concat(source, ")"),
    width: size,
    height: size
  }), loading && /*#__PURE__*/_react.default.createElement(_Shimmer.default, {
    width: "100%",
    height: "100%"
  }));
};

Avatar.propTypes = propTypes;
const AvatarWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    units,
    radius
  } = _ref2;
  return {
    avatar: {
      borderRadius: '50%',
      overflow: 'hidden',
      backgroundSize: 'cover',
      backgroundColor: color.gray,
      backgroundPosition: 'center'
    },
    avatar_inline: {
      display: 'inline-block'
    },
    avatar_micro: {
      width: units(1.5),
      height: units(1.5)
    },
    avatar_small: {
      width: units(2.5),
      height: units(2.5)
    },
    avatar_medium: {
      width: units(3.5),
      height: units(3.5)
    },
    avatar_large: {
      width: units(5),
      height: units(5)
    },
    avatar_square: {
      borderRadius: radius
    }
  };
})(Avatar);
var _default = AvatarWithStyles;
exports.default = _default;