"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Text = _interopRequireDefault(require("./Text"));

var _Tooltip = _interopRequireDefault(require("./Tooltip"));

var _Avatar = _interopRequireDefault(require("./Avatar"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  large: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  small: _propTypes.default.bool,
  square: _propTypes.default.string,
  apps: _propTypes.default.array,
  showItems: _propTypes.default.number,
  messageTop: _propTypes.default.bool,
  messageBottom: _propTypes.default.bool,
  messageLeft: _propTypes.default.bool,
  messageRight: _propTypes.default.bool
};

const AvatarGroup = _ref => {
  let {
    css,
    large,
    micro,
    small,
    square,
    styles,
    apps,
    showItems = 4,
    messageTop,
    messageBottom,
    messageRight,
    messageLeft
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.container), apps.filter((app, count) => count < showItems).map(app => {
    return /*#__PURE__*/_react.default.createElement("div", css(styles.avatar, square && styles.squareAvatar), /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
      top: messageTop,
      left: messageLeft,
      right: messageRight,
      bottom: messageBottom,
      text: app && app.name
    }, /*#__PURE__*/_react.default.createElement(_Avatar.default, {
      source: app.url,
      small: small,
      micro: micro,
      large: large,
      square: square
    })));
  }), apps.length > showItems && /*#__PURE__*/_react.default.createElement("div", css(styles.others), /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
    top: messageTop,
    left: messageLeft,
    right: messageRight,
    bottom: messageBottom,
    text: apps.filter((app, count) => count >= showItems).map((app, count) => /*#__PURE__*/_react.default.createElement(_Text.default, {
      key: app ? app.name : count,
      micro: true,
      center: true,
      inverse: true,
      truncate: true
    }, app && app.name))
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    muted: true,
    bold: true
  }, "+".concat(apps.length - showItems)))));
};

AvatarGroup.propTypes = propTypes;
const AvatarGroupWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    units,
    radius
  } = _ref2;
  return {
    container: {
      display: 'flex',
      alignItems: 'center',
      position: 'relateive'
    },
    avatar: {
      borderRadius: '50%',
      marginLeft: units(-1),
      backgroundColor: color.blueGray,
      boxShadow: '3px 3px 3px -1px #d3d3d3',
      ':nth-child(1)': {
        marginLeft: 0
      }
    },
    squareAvatar: {
      borderRadius: 0
    },
    others: {
      borderRadius: radius,
      cursor: 'pointer',
      marginLeft: units(0.8)
    }
  };
})(AvatarGroup);
var _default = AvatarGroupWithStyles;
exports.default = _default;