"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _withStyles = require("../helpers/withStyles");

var _CinnectaTheme = _interopRequireDefault(require("../themes/CinnectaTheme"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const Block = _ref => {
  let {
    alignCenter,
    alignEnd,
    alignStart,
    border,
    column,
    css,
    children,
    fullHeight,
    justifyCenter,
    justifyEnd,
    justifyStart,
    gray,
    horizontal,
    largePadding,
    maxWidth,
    minWidth,
    noPadding,
    rectangular,
    transparent,
    styles
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.container, alignCenter && styles.alignCenter, alignEnd && styles.alignEnd, alignStart && styles.alignStart, border && styles.border, column && styles.column, fullHeight && styles.fullHeight, gray && styles.container_gray, horizontal ? styles.row : styles.column, justifyCenter && styles.justifyCenter, justifyEnd && styles.justifyEnd, justifyStart && styles.justifyStart, largePadding && styles.largePadding, !transparent && !gray && styles.background, !rectangular && styles.radius, noPadding && styles.noPadding, {
    maxWidth: maxWidth && maxWidth * _CinnectaTheme.default.unit,
    minWidth: minWidth && minWidth * _CinnectaTheme.default.unit
  }), children);
};

const BlockWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    units,
    radius
  } = _ref2;
  return {
    container: {
      borderRadius: radius,
      padding: units(1)
    },
    background: {
      background: color.white
    },
    alignCenter: {
      display: 'flex',
      alignItems: 'center'
    },
    alignEnd: {
      display: 'flex',
      alignItems: 'flex-end'
    },
    alignStart: {
      display: 'flex',
      alignItems: 'flex-start'
    },
    justifyCenter: {
      display: 'flex',
      justifyContent: 'center'
    },
    justifyEnd: {
      display: 'flex',
      justifyContent: 'flex-end'
    },
    justifyStart: {
      display: 'flex',
      justifyContent: 'flex-start'
    },
    row: {
      flexDirection: 'row'
    },
    column: {
      flexDirection: 'column'
    },
    noPadding: {
      padding: 0
    },
    largePadding: {
      padding: units(2)
    },
    container_gray: {
      background: color.grayLight
    },
    border: {
      borderWidth: 1,
      borderStyle: 'solid',
      borderColor: color.gray
    },
    fullHeight: {
      height: '100%'
    },
    radius: {
      borderRadius: radius
    }
  };
})(Block);
var _default = BlockWithStyles;
exports.default = _default;