"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  disabled: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  fullWidth: _propTypes.default.bool,
  block: _propTypes.default.bool,
  compact: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  mono: _propTypes.default.bool,
  noSpacing: _propTypes.default.bool,
  soft: _propTypes.default.bool,
  primary: _propTypes.default.bool,
  rectangular: _propTypes.default.bool,
  secondary: _propTypes.default.bool,
  shade: _propTypes.default.bool,
  shimmer: _propTypes.default.bool,
  short: _propTypes.default.bool,
  transparent: _propTypes.default.bool,
  type: _propTypes.default.string,
  noBorder: _propTypes.default.bool,
  children: _propTypes.default.node
};
const defaultProps = {
  type: 'button'
};

const ButtonGroup = _ref => {
  let {
    styles,
    children,
    disabled,
    loading,
    fullWidth,
    block,
    compact,
    inverse,
    grouped,
    groupedFirst,
    groupedLast,
    mono,
    noSpacing,
    shade,
    soft,
    primary,
    rectangular,
    secondary,
    shimmer,
    short,
    transparent,
    type,
    underlined,
    noBorder,
    theme,
    css,
    href,
    large,
    noWrap,
    shadowLevel,
    small,
    ...props
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.buttonGroup, loading && styles.button_loading, fullWidth && styles.button_fullWidth, block && styles.button_block, grouped && styles.button_grouped, groupedFirst && styles.button_groupedFirst, groupedLast && styles.button_groupedLast, noSpacing && styles.button_noSpacing), _react.Children.map(children, (child, i) => {
    const button = /*#__PURE__*/_react.default.cloneElement(child, {
      compact: compact,
      disabled: disabled,
      inverse: inverse,
      rectangular: rectangular || i > 0 && i < children.length - 1,
      grouped: true,
      groupedFirst: i === 0,
      groupedLast: i === children.length - 1,
      fullWidth: fullWidth,
      mono: mono,
      primary: primary,
      secondary: secondary,
      shade: shade,
      short: short,
      soft: soft,
      transparent: transparent,
      underlined: underlined
    });

    return fullWidth ? /*#__PURE__*/_react.default.createElement("div", css(styles.buttonContainer), button) : button;
  }));
};

ButtonGroup.propTypes = propTypes;
ButtonGroup.defaultProps = defaultProps;
const ButtonGroupWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    units,
    font,
    animation,
    radius
  } = _ref2;
  return {
    buttonGroup: {
      marginBottom: units(0.5),
      boxSizing: 'border-box',
      display: 'flex'
    },
    button_soft: {
      backgroundColor: color.blueGrayLighter,
      color: color.primary,
      ':hover': {
        backgroundColor: color.blueGrayLight
      },
      ':active': {
        backgroundColor: color.blueGray
      }
    },
    button_fullWidth: {
      width: '100%'
    },
    button_loading: {
      opacity: 1,
      pointerEvents: 'none'
    },
    button_block: {
      width: '100%',
      textAlign: 'left',
      marginRight: 0,
      marginLeft: 0
    },
    button_compact: {
      paddingRight: units(0.75),
      paddingLeft: units(0.75)
    },
    button_shade: {
      background: color.shadowWeakest,
      ':hover': {
        background: color.shadowWeaker
      },
      ':active': {
        background: color.shadowWeak
      }
    },
    button_short: {
      height: units(2)
    },
    button_grouped: {
      marginRight: 1,
      marginBottom: 0,
      marginLeft: 1
    },
    button_groupedFirst: {
      borderRadius: "0 0 ".concat(radius, "px ").concat(radius, "px")
    },
    button_disabled: {
      opacity: .5,
      pointerEvents: 'none'
    },
    button_mono: {
      backgroundColor: color.transparent,
      borderColor: color.black,
      borderWidth: 1,
      borderStyle: 'solid',
      color: color.black,
      ':hover': {
        background: 'none'
      },
      ':active': {
        backgroundColor: color.grayLighter
      }
    },
    button_noSpacing: {
      marginBottom: 0
    },
    button_primary: {
      backgroundColor: color.primary,
      ':hover': {
        background: color.primarySaturated
      },
      ':active': {
        background: color.primaryDarker
      }
    },
    button_secondary: {
      backgroundColor: color.transparent,
      borderColor: color.secondary,
      borderWidth: 1,
      borderStyle: 'solid',
      color: color.secondary,
      ':hover': {
        color: color.secondarySaturated,
        backgroundColor: color.grayLightest
      },
      ':active': {
        borderColor: color.secondaryDarker,
        backgroundColor: color.grayLighter
      }
    },
    button_inverse: {
      backgroundColor: color.white,
      color: color.primary,
      borderWidth: 0,
      ':hover': {
        backgroundColor: color.blueGrayLight
      },
      ':active': {
        backgroundColor: color.blueGray
      }
    },
    button_transparent: {
      backgroundColor: color.transparent,
      color: color.primary,
      ':hover': {
        background: color.shadowWeakest
      },
      ':active': {
        background: color.shadowWeaker
      }
    },
    button_rectangular: {
      borderRadius: 0
    },
    button_noBorder: {
      border: 'none',
      borderWidth: 0
    },
    button__content: {
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'flex-start',
      opacity: 1,
      transition: 'opacity .2s',
      whiteSpace: 'nowrap',
      userSelect: 'none'
    },
    button__content_loading: {
      opacity: 0
    },
    button__content_fullWidth: {
      justifyContent: 'center'
    },
    button__loader: {
      position: 'absolute',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    },
    buttonContainer: {
      flex: 1
    },
    shimmer: {
      position: 'absolute',
      width: '100%',
      height: '100%',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    }
  };
})(ButtonGroup);
var _default = ButtonGroupWithStyles;
exports.default = _default;