"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _CinnectaTheme = _interopRequireDefault(require("../themes/CinnectaTheme"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  children: _propTypes.default.any,
  size: _propTypes.default.number,
  mediumSize: _propTypes.default.number,
  largeSize: _propTypes.default.number,
  xlargeSize: _propTypes.default.number,
  columns: _propTypes.default.number,
  columnsOnMedium: _propTypes.default.number,
  columnsOnLarge: _propTypes.default.number,
  columnsOnXlarge: _propTypes.default.number,
  fit: _propTypes.default.bool,
  fitOnMedium: _propTypes.default.bool,
  fitOnLarge: _propTypes.default.bool,
  fitOnXlarge: _propTypes.default.bool,
  fullHeight: _propTypes.default.bool,
  fullHeightOnMedium: _propTypes.default.bool,
  fullHeightOnLarge: _propTypes.default.bool,
  fullHeightOnXlarge: _propTypes.default.bool,
  microSpacing: _propTypes.default.bool,
  smallSpacing: _propTypes.default.bool,
  largeSpacing: _propTypes.default.bool,
  noSpacing: _propTypes.default.bool,
  verticalSpacing: _propTypes.default.bool,
  microVerticalSpacing: _propTypes.default.bool,
  smallVerticalSpacing: _propTypes.default.bool,
  largeVerticalSpacing: _propTypes.default.bool,
  auto: _propTypes.default.bool,
  autoOnMedium: _propTypes.default.bool,
  autoOnLarge: _propTypes.default.bool,
  autoOnXlarge: _propTypes.default.bool,
  relative: _propTypes.default.bool,
  shrink: _propTypes.default.bool,
  shrinkOnMedium: _propTypes.default.bool,
  shrinkOnLarge: _propTypes.default.bool,
  shrinkOnXlarge: _propTypes.default.bool,
  grow: _propTypes.default.bool,
  growOnMedium: _propTypes.default.bool,
  growOnLarge: _propTypes.default.bool,
  growOnXlarge: _propTypes.default.bool,
  order: _propTypes.default.number,
  maxWidth: _propTypes.default.number,
  minWidth: _propTypes.default.number,
  scroll: _propTypes.default.bool
};

const Cell = _ref => {
  let {
    children,
    size,
    mediumSize,
    largeSize,
    xlargeSize,
    columns,
    columnsOnMedium,
    columnsOnLarge,
    columnsOnXlarge,
    fit,
    fitOnMedium,
    fitOnLarge,
    fitOnXlarge,
    fullHeight,
    fullHeightOnMedium,
    fullHeightOnLarge,
    fullHeightOnXlarge,
    microSpacing,
    smallSpacing,
    largeSpacing,
    noSpacing,
    verticalSpacing,
    microVerticalSpacing,
    smallVerticalSpacing,
    largeVerticalSpacing,
    auto,
    autoOnMedium,
    autoOnLarge,
    autoOnXlarge,
    relative,
    shrink,
    shrinkOnMedium,
    shrinkOnLarge,
    shrinkOnXlarge,
    grow,
    growOnMedium,
    growOnLarge,
    growOnXlarge,
    order,
    maxWidth,
    minWidth,
    scroll,
    customStyle,
    css,
    styles
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.cell, size && styles["cell_".concat(size)], mediumSize && styles["cell_medium_".concat(mediumSize)], largeSize && styles["cell_large_".concat(largeSize)], xlargeSize && styles["cell_xlarge_".concat(xlargeSize)], columns && styles["cell_columns_".concat(columns)], columnsOnMedium && styles["cell_columns_medium_".concat(columnsOnMedium)], columnsOnLarge && styles["cell_columns_large_".concat(columnsOnLarge)], columnsOnXlarge && styles["cell_columns_xlarge_".concat(columnsOnXlarge)], auto && styles.cell_auto, autoOnMedium && styles.cell_auto_medium, autoOnLarge && styles.cell_auto_large, autoOnXlarge && styles.cell_auto_xlarge, fullHeight && styles.cell_fullHeight, fullHeightOnMedium && styles.cell_fullHeight_medium, fullHeightOnLarge && styles.cell_fullHeight_large, fullHeightOnXlarge && styles.cell_fullHeight_xlarge, relative && styles.relative, shrink && styles.cell_shrink, shrinkOnMedium && styles.cell_shrink_medium, shrinkOnLarge && styles.cell_shrink_large, shrinkOnXlarge && styles.cell_shrink_xlarge, grow && styles.cell_grow, growOnMedium && styles.cell_grow_medium, growOnLarge && styles.cell_grow_large, growOnXlarge && styles.cell_grow_xlarge, fit && styles.cell_fit, fitOnMedium && styles.cell_fit_medium, fitOnLarge && styles.cell_fit_large, fitOnXlarge && styles.cell_fit_xlarge, microSpacing && styles.cell_microSpacing, smallSpacing && styles.cell_smallSpacing, largeSpacing && styles.cell_largeSpacing, verticalSpacing && styles.cell_verticalSpacing, microVerticalSpacing && styles.cell_verticalSpacing_micro, smallVerticalSpacing && styles.cell_verticalSpacing_small, largeVerticalSpacing && styles.cell_verticalSpacing_large, noSpacing && styles.cell_noSpacing, scroll && styles.cell_scroll, {
    order: order,
    maxWidth: maxWidth && maxWidth * _CinnectaTheme.default.unit,
    minWidth: minWidth && minWidth * _CinnectaTheme.default.unit
  }, customStyle), children);
};

Cell.propTypes = propTypes;
const CellWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    breakpoint,
    gutter,
    columns
  } = _ref2;
  let sizes = {};

  for (let size = 1; size <= columns; size++) {
    sizes["cell_".concat(size)] = {
      width: "".concat(size / columns * 100, "%")
    };
    sizes["cell_medium_".concat(size)] = {
      [breakpoint.mediumAndAbove]: {
        width: "".concat(size / columns * 100, "%")
      }
    };
    sizes["cell_large_".concat(size)] = {
      [breakpoint.large]: {
        width: "".concat(size / columns * 100, "%")
      }
    };
    sizes["cell_xlarge_".concat(size)] = {
      [breakpoint.xlarge]: {
        width: "".concat(size / columns * 100, "%")
      }
    };
    sizes["cell_columns_".concat(size)] = {
      width: "".concat(100 / size, "%")
    };
    sizes["cell_columns_medium_".concat(size)] = {
      [breakpoint.mediumAndAbove]: {
        width: "".concat(100 / size, "%")
      }
    };
    sizes["cell_columns_large_".concat(size)] = {
      [breakpoint.large]: {
        width: "".concat(100 / size, "%")
      }
    };
    sizes["cell_columns_xlarge_".concat(size)] = {
      [breakpoint.xlarge]: {
        width: "".concat(100 / size, "%")
      }
    };
  }

  return {
    cell: {
      //display: 'flex',
      paddingLeft: gutter.small.regular.left,
      paddingRight: gutter.small.regular.right,
      boxSizing: 'border-box',
      [breakpoint.mediumAndAbove]: {
        paddingLeft: gutter.medium.regular.left,
        paddingRight: gutter.medium.regular.right
      },
      [breakpoint.large]: {
        paddingLeft: gutter.large.regular.left,
        paddingRight: gutter.large.regular.right
      },
      [breakpoint.xlarge]: {
        paddingLeft: gutter.xlarge.regular.left,
        paddingRight: gutter.xlarge.regular.right
      }
    },
    cell_fullHeight: {
      height: '100%' //minHeight: '100%'

    },
    cell_fullHeight_medium: {
      [breakpoint.mediumAndAbove]: {
        height: '100%' //minHeight: '100%'

      }
    },
    cell_fullHeight_large: {
      [breakpoint.large]: {
        height: '100%' //minHeight: '100%'

      }
    },
    cell_fullHeight_xlarge: {
      [breakpoint.xlarge]: {
        height: '100%' //minHeight: '100%'

      }
    },
    cell_microSpacing: {
      paddingLeft: gutter.small.micro.left,
      paddingRight: gutter.small.micro.right,
      [breakpoint.mediumAndAbove]: {
        paddingLeft: gutter.medium.micro.left,
        paddingRight: gutter.medium.micro.right
      },
      [breakpoint.large]: {
        paddingLeft: gutter.large.micro.left,
        paddingRight: gutter.large.micro.right
      },
      [breakpoint.xlarge]: {
        paddingLeft: gutter.xlarge.micro.left,
        paddingRight: gutter.xlarge.micro.right
      }
    },
    cell_smallSpacing: {
      paddingLeft: gutter.small.small.left,
      paddingRight: gutter.small.small.right,
      [breakpoint.mediumAndAbove]: {
        paddingLeft: gutter.medium.small.left,
        paddingRight: gutter.medium.small.right
      },
      [breakpoint.large]: {
        paddingLeft: gutter.large.small.left,
        paddingRight: gutter.large.small.right
      },
      [breakpoint.xlarge]: {
        paddingLeft: gutter.xlarge.small.left,
        paddingRight: gutter.xlarge.small.right
      }
    },
    cell_largeSpacing: {
      paddingLeft: gutter.small.large.left,
      paddingRight: gutter.small.large.right,
      [breakpoint.mediumAndAbove]: {
        paddingLeft: gutter.medium.large.left,
        paddingRight: gutter.medium.large.right
      },
      [breakpoint.large]: {
        paddingLeft: gutter.large.large.left,
        paddingRight: gutter.large.large.right
      },
      [breakpoint.xlarge]: {
        paddingLeft: gutter.xlarge.large.left,
        paddingRight: gutter.xlarge.large.right
      }
    },
    cell_verticalSpacing: {
      paddingTop: gutter.small.regular.top,
      paddingBottom: gutter.small.regular.bottom,
      [breakpoint.mediumAndAbove]: {
        paddingTop: gutter.medium.regular.top,
        paddingBottom: gutter.medium.regular.bottom
      },
      [breakpoint.large]: {
        paddingTop: gutter.large.regular.top,
        paddingBottom: gutter.large.regular.bottom
      },
      [breakpoint.xlarge]: {
        paddingTop: gutter.xlarge.regular.top,
        paddingBottom: gutter.xlarge.regular.bottom
      }
    },
    cell_verticalSpacing_micro: {
      paddingTop: gutter.small.micro.top,
      paddingBottom: gutter.small.micro.bottom,
      [breakpoint.mediumAndAbove]: {
        paddingTop: gutter.medium.micro.top,
        paddingBottom: gutter.medium.micro.bottom
      },
      [breakpoint.large]: {
        paddingTop: gutter.large.micro.top,
        paddingBottom: gutter.large.micro.bottom
      },
      [breakpoint.xlarge]: {
        paddingTop: gutter.xlarge.micro.top,
        paddingBottom: gutter.xlarge.micro.bottom
      }
    },
    cell_verticalSpacing_small: {
      paddingTop: gutter.small.small.top,
      paddingBottom: gutter.small.small.bottom,
      [breakpoint.mediumAndAbove]: {
        paddingTop: gutter.medium.small.top,
        paddingBottom: gutter.medium.small.bottom
      },
      [breakpoint.large]: {
        paddingTop: gutter.large.small.top,
        paddingBottom: gutter.large.small.bottom
      },
      [breakpoint.xlarge]: {
        paddingTop: gutter.xlarge.small.top,
        paddingBottom: gutter.xlarge.small.bottom
      }
    },
    cell_verticalSpacing_large: {
      paddingTop: gutter.small.large.top,
      paddingBottom: gutter.small.large.bottom,
      [breakpoint.mediumAndAbove]: {
        paddingTop: gutter.medium.large.top,
        paddingBottom: gutter.medium.large.bottom
      },
      [breakpoint.large]: {
        paddingTop: gutter.large.large.top,
        paddingBottom: gutter.large.large.bottom
      },
      [breakpoint.xlarge]: {
        paddingTop: gutter.xlarge.large.top,
        paddingBottom: gutter.xlarge.large.bottom
      }
    },
    cell_noSpacing: {
      paddingTop: 0,
      paddingRight: 0,
      paddingBottom: 0,
      paddingLeft: 0,
      [breakpoint.mediumAndAbove]: {
        paddingTop: 0,
        paddingRight: 0,
        paddingBottom: 0,
        paddingLeft: 0
      },
      [breakpoint.large]: {
        paddingTop: 0,
        paddingRight: 0,
        paddingBottom: 0,
        paddingLeft: 0
      },
      [breakpoint.xlarge]: {
        paddingTop: 0,
        paddingRight: 0,
        paddingBottom: 0,
        paddingLeft: 0
      }
    },
    cell_auto: {
      flex: '1 1 0',
      width: 'auto'
    },
    cell_auto_medium: {
      [breakpoint.mediumAndAbove]: {
        flex: '1 1 0',
        width: 'auto'
      }
    },
    cell_auto_large: {
      [breakpoint.large]: {
        flex: '1 1 0',
        width: 'auto'
      }
    },
    cell_auto_xlarge: {
      [breakpoint.xlarge]: {
        flex: '1 1 0',
        width: 'auto'
      }
    },
    cell_shrink: {
      flex: '0 0 auto',
      width: 'auto'
    },
    cell_shrink_medium: {
      [breakpoint.mediumAndAbove]: {
        flex: '0 0 auto',
        width: 'auto'
      }
    },
    cell_shrink_large: {
      [breakpoint.large]: {
        flex: '0 0 auto',
        width: 'auto'
      }
    },
    cell_shrink_xlarge: {
      [breakpoint.xlarge]: {
        flex: '0 0 auto',
        width: 'auto'
      }
    },
    cell_fit: {
      flex: '0 1 auto',
      width: 'auto'
    },
    cell_fit_medium: {
      [breakpoint.mediumAndAbove]: {
        flex: '0 1 auto',
        width: 'auto'
      }
    },
    cell_fit_large: {
      [breakpoint.large]: {
        flex: '0 1 auto',
        width: 'auto'
      }
    },
    cell_fit_xlarge: {
      [breakpoint.xlarge]: {
        flex: '0 1 auto',
        width: 'auto'
      }
    },
    cell_grow: {
      flex: '1 0 auto',
      width: 'auto'
    },
    cell_grow_medium: {
      [breakpoint.mediumAndAbove]: {
        flex: '1 0 auto',
        width: 'auto'
      }
    },
    cell_grow_large: {
      [breakpoint.large]: {
        flex: '1 0 auto',
        width: 'auto'
      }
    },
    cell_grow_xlarge: {
      [breakpoint.xlarge]: {
        flex: '1 0 auto',
        width: 'auto'
      }
    },
    cell_scroll: {
      overflow: 'auto'
    },
    relative: {
      position: 'relative'
    },
    ...sizes
  };
}, {
  flushBefore: true
})(Cell);
var _default = CellWithStyles;
exports.default = _default;