"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Label = _interopRequireDefault(require("./Label"));

var _CheckboxOnly = _interopRequireDefault(require("./CheckboxOnly"));

var _Text = _interopRequireDefault(require("./Text"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  boldLabel: _propTypes.default.bool,
  checked: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  id: _propTypes.default.string,
  invalid: _propTypes.default.bool,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  name: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  pullRight: _propTypes.default.bool,
  refForFocus: _propTypes.default.func,
  smallLabel: _propTypes.default.bool,
  subtitle: _propTypes.default.string
};
const defaultProps = {
  label: '',
  radioButton: false
};

const Checkbox = _ref => {
  let {
    checked,
    css,
    disabled,
    id,
    invalid,
    label,
    name,
    onBlur,
    onChange,
    onFocus,
    pullRight,
    refForFocus,
    styles,
    subtitle,
    smallLabel,
    boldLabel
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(_Label.default, {
    htmlFor: id
  }, /*#__PURE__*/_react.default.createElement("div", css(styles.column, pullRight && styles.pullRight), /*#__PURE__*/_react.default.createElement(_CheckboxOnly.default, {
    id: id,
    checked: checked,
    disabled: disabled,
    invalid: invalid,
    name: name,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus
  })), label && /*#__PURE__*/_react.default.createElement("div", css(styles.column, pullRight ? styles.marginRight : styles.spacing), /*#__PURE__*/_react.default.createElement("div", css(styles.checkbox__label), typeof label === 'string' ? /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: smallLabel,
    bold: boldLabel,
    disabled: disabled
  }, label) : label), subtitle && checked && /*#__PURE__*/_react.default.createElement("div", css(styles.subtitle), /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true
  }, subtitle))));
};

Checkbox.propTypes = propTypes;
Checkbox.defaultProps = defaultProps;
const CheckboxWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    units,
    color,
    font,
    fontSize,
    weight,
    lineHeight,
    breakpoint
  } = _ref2;
  return {
    checkbox: {},
    column: {
      display: 'table-cell',
      verticalAlign: 'top',
      whiteSpace: 'normal'
    },
    checkbox__label: {
      color: color.grayDarker,
      cursor: 'pointer',
      display: 'inline-block',
      wordWrap: 'break-word',
      letterSpacing: 'normal',
      fontFamily: font.default,
      fontWeight: weight.normal,
      fontSize: fontSize.small.regular,
      lineHeight: lineHeight.regular,
      [breakpoint.large]: {
        fontSize: fontSize.large.regular
      }
    },
    spacing: {
      paddingLeft: 12
    },
    marginRight: {
      marginRight: 32
    },
    pullRight: {
      float: 'right'
    },
    subtitle: {
      paddingTop: 2
    }
  };
})(Checkbox);
var _default = CheckboxWithStyles;
exports.default = _default;