"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactWithStyles = require("react-with-styles");

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  children: _propTypes.default.any.isRequired,
  disabled: _propTypes.default.bool,
  inline: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  onClick: _propTypes.default.func,
  rectangular: _propTypes.default.bool
};

const Clickable = _ref => {
  let {
    children,
    css,
    disabled,
    inline,
    inverse,
    onClick,
    rectangular,
    styles
  } = _ref;
  return inline ? /*#__PURE__*/_react.default.createElement("span", _extends({
    onClick: onClick
  }, css(styles.clickable, disabled && styles.clickable_disabled, inverse && styles.clickable_inverse, rectangular && styles.clickable_rectangular)), children) : /*#__PURE__*/_react.default.createElement("div", _extends({
    onClick: onClick
  }, css(styles.clickable, disabled && styles.clickable_disabled, inverse && styles.clickable_inverse, rectangular && styles.clickable_rectangular)), children);
};

Clickable.propTypes = propTypes;
const ClickableWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    radius
  } = _ref2;
  return {
    clickable: {
      cursor: 'pointer',
      borderRadius: radius,
      ':hover': {
        background: color.shadowWeakest
      },
      ':active': {
        background: color.shadowWeaker
      }
    },
    clickable_disabled: {
      pointerEvents: 'none',
      opacity: 0.5
    },
    clickable_inverse: {
      ':hover': {
        background: color.fogWeakest
      },
      ':active': {
        background: color.fogWeaker
      }
    },
    clickable_rectangular: {
      borderRadius: 0
    }
  };
})(Clickable);
var _default = ClickableWithStyles;
exports.default = _default;