"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _withStyles = require("../helpers/withStyles");

var _PageHeader = _interopRequireDefault(require("./PageHeader"));

var _Wrapper = _interopRequireDefault(require("./Wrapper"));

var _Spacing = _interopRequireDefault(require("./Spacing"));

var _Grid = _interopRequireDefault(require("./Grid"));

var _Cell = _interopRequireDefault(require("./Cell"));

var _Text = _interopRequireDefault(require("./Text"));

var _Icon = _interopRequireDefault(require("./Icon"));

var _FlatButton = _interopRequireDefault(require("./FlatButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

class ConfigurationBox extends _react.Component {
  render() {
    const {
      actions,
      children,
      closable,
      css,
      description,
      header,
      onClose,
      styles,
      title
    } = this.props;
    return /*#__PURE__*/_react.default.createElement("div", css(styles.configurationBox), /*#__PURE__*/_react.default.createElement("div", css(styles.configurationBox__header), /*#__PURE__*/_react.default.createElement(_Grid.default, {
      center: true
    }, /*#__PURE__*/_react.default.createElement(_Cell.default, {
      auto: true,
      noSpacing: true
    }, /*#__PURE__*/_react.default.createElement(_PageHeader.default, {
      title: title,
      description: description,
      level: 2,
      removeMargin: true,
      removeDescriptionSpacing: description != null
    }, actions)), closable && /*#__PURE__*/_react.default.createElement(_Cell.default, {
      shrink: true,
      noSpacing: true
    }, /*#__PURE__*/_react.default.createElement("div", css(styles.closeButtonContainer), /*#__PURE__*/_react.default.createElement(_FlatButton.default, {
      transparent: true,
      icon: /*#__PURE__*/_react.default.createElement(_Icon.default, {
        name: "error",
        large: true
      }),
      onClick: () => onClose && onClose()
    }))))), /*#__PURE__*/_react.default.createElement("div", css(styles.configurationBox__body), header && Array.isArray(header) && header.length > 0 && /*#__PURE__*/_react.default.createElement("div", css(styles.configurationBox__header), /*#__PURE__*/_react.default.createElement(_Grid.default, {
      resetSpacing: true
    }, header.map((headerItem, count) => {
      return /*#__PURE__*/_react.default.createElement(_Cell.default, {
        size: 12,
        key: count,
        shrinkOnMedium: true
      }, /*#__PURE__*/_react.default.createElement("div", css(styles.configurationBox__header__item, styles.padded, count + 1 < header.length && styles.borderRight), /*#__PURE__*/_react.default.createElement(_Text.default, {
        bold: true
      }, headerItem.label), /*#__PURE__*/_react.default.createElement(_Text.default, {
        large: true
      }, headerItem.content)));
    }))), /*#__PURE__*/_react.default.createElement(_Spacing.default, {
      top: 2
    }, /*#__PURE__*/_react.default.createElement(_Wrapper.default, null, children))));
  }

}

const ConfigurationBoxWithStyles = (0, _withStyles.withStyles)(_ref => {
  let {
    color,
    units,
    radius,
    font,
    breakpoint
  } = _ref;
  return {
    configurationBox: {
      display: 'flex',
      flexDirection: 'column',
      height: '100%',
      fontFamily: font.default
    },
    configurationBox__header: {
      paddingRight: units(1.5),
      paddingLeft: units(1.5),
      borderBottomWidth: 1,
      borderBottomColor: color.blueGrayLight,
      borderBottomStyle: 'solid',
      background: color.white,
      [breakpoint.large]: {
        paddingRight: units(3),
        paddingLeft: units(3)
      }
    },
    configurationBox__header__item: {
      paddingRight: units(2)
    },
    padded: {
      paddingTop: units(.5),
      paddingBottom: units(.5),
      [breakpoint.mediumAndAbove]: {
        paddingTop: units(1),
        paddingBottom: units(1)
      }
    },
    borderRight: {
      [breakpoint.mediumAndAbove]: {
        borderRightWidth: 1,
        borderRightColor: color.blueGrayLight,
        borderRightStyle: 'solid'
      }
    },
    configurationBox__body: {
      flex: 1,
      background: color.blueGrayLightest,
      overflow: 'auto',
      paddingBottom: units(4)
    },
    configurationBox__bullet: {
      width: 6,
      height: 6,
      background: color.grayDarker,
      borderRadius: '50%',
      marginTop: 8
    },
    closeButtonContainer: {
      position: 'absolute',
      right: units(1),
      top: units(1),
      [breakpoint.mediumAndAbove]: {
        position: 'static',
        borderLeftWidth: 1,
        borderLeftColor: color.blueGray,
        borderLeftStyle: 'solid',
        marginLeft: 16,
        paddingLeft: 8
      }
    }
  };
})(ConfigurationBox);
var _default = ConfigurationBoxWithStyles;
exports.default = _default;