"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _withStyles = require("../helpers/withStyles");

var _Blanket = _interopRequireDefault(require("./Blanket"));

var _Transition = _interopRequireDefault(require("react-transition-group/Transition"));

var _FlatButton = _interopRequireDefault(require("./FlatButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const defaultProps = {
  closeOnClickOutside: true
};

const Drawer = _ref => {
  let {
    active,
    children,
    closeOnClickOutside,
    css,
    elevated,
    fixed,
    fullWidth,
    global,
    large,
    micro,
    onClose,
    onClosed,
    right,
    removeBlanket,
    primaryBlanket,
    small,
    width,
    withBorder,
    styles,
    removeCloseButton,
    fixedCloseButton,
    zIndex
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement("div", css(styles.container, fixed ? styles.drawer_fixed : styles.drawer_absolute, zIndex && {
    zIndex
  }), /*#__PURE__*/_react.default.createElement(_Transition.default, {
    in: active,
    timeout: 250 //mountOnEnter
    //unmountOnExit
    ,
    onEnter: node => node.scrollTop,
    onExited: () => onClosed && onClosed()
  }, state => /*#__PURE__*/_react.default.createElement("div", css(styles.drawer, elevated && state !== 'exited' && styles.drawer_elevated, !fullWidth && !micro && !small && !large && styles.drawer_medium, micro && styles.drawer_micro, small && styles.drawer_small, large && styles.drawer_large, right ? styles.drawer_right : styles.drawer_left, withBorder && (right ? styles.drawer_borderLeft : styles.drawer_borderRight), (state === 'entering' || state === 'entered') && styles.entering, right ? (state === 'exiting' || state === 'exited') && styles.exiting : (state === 'exiting' || state === 'exited') && styles.exiting_left), !removeCloseButton && /*#__PURE__*/_react.default.createElement("div", css(styles.closeButton, fixedCloseButton && styles.closeButton_fixed), /*#__PURE__*/_react.default.createElement(_FlatButton.default, {
    transparent: true,
    icon: "error",
    onClick: () => onClose && onClose()
  })), children))), !removeBlanket && /*#__PURE__*/_react.default.createElement(_Blanket.default, {
    global: global,
    primary: primaryBlanket,
    visible: active,
    onClick: () => onClose && closeOnClickOutside && onClose()
  }));
};

Drawer.defaultProps = defaultProps;
const DrawerWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    units
  } = _ref2;
  return {
    container: {
      left: 0,
      right: 0,
      top: 0,
      width: '100%',
      minHeight: '100%',
      overflowX: 'hidden',
      pointerEvents: 'none',
      zIndex: 100
    },
    drawer: {
      background: color.white,
      top: 0,
      bottom: 0,
      width: '100%',
      overflowX: 'hidden',
      overflowY: 'auto',
      zIndex: 100,
      transition: 'transform 250ms ease-out, box-shadow 250ms ease-out',
      position: 'absolute',
      pointerEvents: 'all'
    },
    drawer_fixed: {
      position: 'fixed'
    },
    drawer_absolute: {
      position: 'absolute'
    },
    drawer_left: {
      left: 0,
      right: 'unset'
    },
    drawer_right: {
      right: 0,
      left: 'unset'
    },
    drawer_micro: {
      maxWidth: 360
    },
    drawer_small: {
      maxWidth: 520
    },
    drawer_medium: {
      maxWidth: 744
    },
    drawer_large: {
      maxWidth: 1128
    },
    drawer_elevated: {
      boxShadow: "0 0 9px 3px ".concat(color.shadowWeak)
    },
    drawer_borderLeft: {
      borderLeftWidth: 1,
      borderLeftStyle: 'solid',
      borderLeftColor: color.gray
    },
    drawer_borderRight: {
      borderRightWidth: 1,
      borderRightStyle: 'solid',
      borderRightColor: color.gray
    },
    entering: {
      transform: 'translate(0, 0)',
      transition: 'transform 250ms ease-out'
    },
    exiting: {
      transform: 'translate(100%, 0)',
      transition: 'transform 250ms ease-out'
    },
    exiting_left: {
      transform: 'translate(-100%, 0)',
      transition: 'transform 250ms ease-out'
    },
    closeButton: {
      marginTop: units(.5),
      marginRight: units(.5),
      float: 'right',
      zIndex: 101
    },
    closeButton_fixed: {
      position: 'absolute',
      right: 0,
      top: 0,
      zIndex: 101
    }
  };
})(Drawer);
var _default = DrawerWithStyles;
exports.default = _default;