"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Text = _interopRequireDefault(require("./Text"));

var _Spacing = _interopRequireDefault(require("./Spacing"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  children: _propTypes.default.any,
  actionLink: _propTypes.default.any,
  errorMessage: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  hideLabel: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  labelDescription: _propTypes.default.string,
  large: _propTypes.default.bool,
  lightLabel: _propTypes.default.bool,
  small: _propTypes.default.bool
};

const FormElement = _ref => {
  let {
    actionLink,
    children,
    css,
    errorMessage,
    hideLabel,
    id,
    inline,
    invalid,
    inverse,
    label,
    labelDescription,
    large,
    lightLabel,
    small,
    styles
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("label", css(styles.formElement, !inline && styles.block), /*#__PURE__*/_react.default.createElement("div", css(styles.label, hideLabel && styles.label_hidden), typeof label === 'string' ? /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    bold: !lightLabel,
    light: lightLabel
  }, label) : label, labelDescription && /*#__PURE__*/_react.default.createElement(_Spacing.default, {
    top: 0.5
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    light: true
  }, labelDescription))), children, invalid && errorMessage && /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    error: true
  }, errorMessage));
};

FormElement.propTypes = propTypes;
const FormElementWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    units
  } = _ref2;
  return {
    formElement: {
      display: 'inline-block'
    },
    block: {
      display: 'block',
      width: '100%'
    },
    label: {
      marginBottom: units(0.5)
    },
    label_hidden: {
      border: 0,
      clip: 'rect(0, 0, 0, 0)',
      display: 'block',
      height: 1,
      margin: -1,
      overflow: 'hidden',
      padding: 0,
      position: 'absolute',
      width: 1
    }
  };
})(FormElement);
var _default = FormElementWithStyles;
exports.default = _default;