"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  children: _propTypes.default.any,
  right: _propTypes.default.bool,
  center: _propTypes.default.bool,
  fullHeight: _propTypes.default.bool,
  spaceBetween: _propTypes.default.bool,
  spaced: _propTypes.default.bool,
  top: _propTypes.default.bool,
  middle: _propTypes.default.bool,
  noWrap: _propTypes.default.bool,
  bottom: _propTypes.default.bool,
  stretch: _propTypes.default.bool,
  resetSpacing: _propTypes.default.bool,
  resetLargeSpacing: _propTypes.default.bool,
  resetMicroSpacing: _propTypes.default.bool,
  resetSmallSpacing: _propTypes.default.bool,
  vertical: _propTypes.default.bool
};

const Grid = _ref => {
  let {
    children,
    right,
    center,
    fullHeight,
    spaceBetween,
    spaced,
    top,
    middle,
    noWrap,
    bottom,
    stretch,
    resetSpacing,
    resetLargeSpacing,
    resetMicroSpacing,
    resetSmallSpacing,
    styles,
    vertical,
    css
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.container, fullHeight && styles.fullHeight), /*#__PURE__*/_react.default.createElement("div", css(styles.grid, fullHeight && styles.fullHeight, right && styles.grid_right, center && styles.grid_center, spaceBetween && styles.grid_spaceBetween, spaced && styles.grid_spaced, top && styles.grid_top, middle && styles.grid_middle, noWrap && styles.grid_noWrap, bottom && styles.grid_bottom, stretch && styles.grid_stretch, resetSpacing && styles.grid_resetSpacing, resetLargeSpacing && styles.grid_resetSpacing_large, resetSmallSpacing && styles.grid_resetSpacing_small, vertical && styles.grid_vertical), children));
};

Grid.propTypes = propTypes;
const GridWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    breakpoint,
    gutter
  } = _ref2;
  return {
    container: {
      display: 'flex',
      width: '100%',
      //flex: 1
      flexBasis: 'auto'
    },
    grid: {
      display: 'flex',
      width: '100%',
      alignItems: 'flex-start',
      flexWrap: 'wrap',
      flexDirection: 'row',
      flex: '1 1 0',
      boxSizing: 'border-box'
    },
    fullHeight: {
      height: '100%' //minHeight: '100%'

    },
    grid_vertical: {
      flexDirection: 'column',
      alignItems: 'stretch'
    },
    grid_noWrap: {
      flexWrap: 'nowrap'
    },
    grid_right: {
      alignItems: 'flex-end'
    },
    grid_center: {
      alignItems: 'center'
    },
    grid_spaceBetween: {
      alignItems: 'space-between'
    },
    grid_spaced: {
      alignItems: 'spaced'
    },
    grid_top: {
      justifyContent: 'flex-start'
    },
    grid_middle: {
      justifyContent: 'center'
    },
    grid_bottom: {
      justifyContent: 'flex-end'
    },
    grid_stretch: {
      alignItems: 'stretch'
    },
    grid_resetSpacing: {
      marginLeft: -gutter.small.regular.left,
      marginRight: -gutter.small.regular.right,
      [breakpoint.mediumAndAbove]: {
        marginLeft: -gutter.medium.regular.left,
        marginRight: -gutter.medium.regular.right
      },
      [breakpoint.large]: {
        marginLeft: -gutter.large.regular.left,
        marginRight: -gutter.large.regular.right
      },
      [breakpoint.xlarge]: {
        marginLeft: -gutter.xlarge.regular.left,
        marginRight: -gutter.xlarge.regular.right
      }
    },
    grid_resetSpacing_large: {
      marginLeft: -gutter.small.large.left,
      marginRight: -gutter.small.large.right,
      [breakpoint.mediumAndAbove]: {
        marginLeft: -gutter.medium.large.left,
        marginRight: -gutter.medium.large.right
      },
      [breakpoint.large]: {
        marginLeft: -gutter.large.large.left,
        marginRight: -gutter.large.large.right
      },
      [breakpoint.xlarge]: {
        marginLeft: -gutter.xlarge.large.left,
        marginRight: -gutter.xlarge.large.right
      }
    },
    grid_resetSpacing_micro: {
      marginLeft: -gutter.small.micro.left,
      marginRight: -gutter.small.micro.right,
      [breakpoint.mediumAndAbove]: {
        marginLeft: -gutter.medium.micro.left,
        marginRight: -gutter.medium.micro.right
      },
      [breakpoint.large]: {
        marginLeft: -gutter.large.micro.left,
        marginRight: -gutter.large.micro.right
      },
      [breakpoint.xlarge]: {
        marginLeft: -gutter.xlarge.micro.left,
        marginRight: -gutter.xlarge.micro.right
      }
    },
    grid_resetSpacing_small: {
      marginLeft: -gutter.small.small.left,
      marginRight: -gutter.small.small.right,
      [breakpoint.mediumAndAbove]: {
        marginLeft: -gutter.medium.small.left,
        marginRight: -gutter.medium.small.right
      },
      [breakpoint.large]: {
        marginLeft: -gutter.large.small.left,
        marginRight: -gutter.large.small.right
      },
      [breakpoint.xlarge]: {
        marginLeft: -gutter.xlarge.small.left,
        marginRight: -gutter.xlarge.small.right
      }
    }
  };
})(Grid);
var _default = GridWithStyles;
exports.default = _default;