"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  inline: _propTypes.default.bool,
  inside: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  aspectRatio: _propTypes.default.number,
  rectangular: _propTypes.default.bool,
  source: _propTypes.default.string,
  transparent: _propTypes.default.bool,
  width: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string])
};
const defaultProps = {
  aspectRatio: 1,
  width: '100%'
};

const Image = _ref => {
  let {
    css,
    inline,
    inside,
    loading,
    aspectRatio,
    rectangular,
    source,
    styles,
    transparent,
    width
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.container, inline && styles.inline, rectangular ? styles.rectangular : styles.radius, {
    width: width
  }), /*#__PURE__*/_react.default.createElement("div", css(styles.image, inside ? styles.image_contain : styles.image_cover, transparent ? styles.transparent : styles.opaque, {
    paddingTop: "".concat(aspectRatio * 100, "%"),
    backgroundImage: source && "url(".concat(source, ")")
  })), loading && /*#__PURE__*/_react.default.createElement("div", css(styles.loading), /*#__PURE__*/_react.default.createElement(_Shimmer.default, {
    width: "100%",
    height: "100%"
  })));
};

Image.propTypes = propTypes;
Image.defaultProps = defaultProps;
const ImageWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    radius
  } = _ref2;
  return {
    container: {
      position: 'relative',
      overflow: 'hidden',
      boxSizing: 'border-box'
    },
    rectangular: {
      borderRadius: 0
    },
    radius: {
      borderRadius: radius
    },
    image: {
      width: '100%',
      backgroundSize: 'cover',
      backgroundPosition: 'center',
      backgroundRepeat: 'no-repeat'
    },
    image_cover: {
      backgroundSize: 'cover'
    },
    image_contain: {
      backgroundSize: 'contain'
    },
    inline: {
      display: 'inline-block'
    },
    loading: {
      position: 'absolute',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    },
    opaque: {
      backgroundColor: color.gray
    },
    transparent: {
      backgroundColor: color.transparent
    }
  };
})(Image);
var _default = ImageWithStyles;
exports.default = _default;