"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormElement = _interopRequireDefault(require("./FormElement"));

var _InputOnly = _interopRequireDefault(require("./InputOnly"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = {
  actionLink: _propTypes.default.string,
  autoCapitalize: _propTypes.default.bool,
  autoComplete: _propTypes.default.oneOf(['off', 'on']),
  autoCorrect: _propTypes.default.any,
  autoFocus: _propTypes.default.bool,
  book: _propTypes.default.bool,
  borderless: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  errorMessage: _propTypes.default.any,
  floating: _propTypes.default.bool,
  focusBorderless: _propTypes.default.bool,
  hideLabel: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  inputRef: _propTypes.default.func,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  label: _propTypes.default.string,
  labelDescription: _propTypes.default.string,
  large: _propTypes.default.bool,
  lightLabel: _propTypes.default.bool,
  mask: _propTypes.default.func,
  maxLength: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  name: _propTypes.default.string.isRequired,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onClear: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  onKeyDown: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  prefix: _propTypes.default.object,
  prefixSeparator: _propTypes.default.bool,
  readOnly: _propTypes.default.bool,
  refForFocus: _propTypes.default.func,
  removeMargins: _propTypes.default.bool,
  removePrefixSpacing: _propTypes.default.bool,
  removeSuffixSpacing: _propTypes.default.bool,
  showFakeValuePlaceholder: _propTypes.default.bool,
  showOverflowEllipsis: _propTypes.default.bool,
  small: _propTypes.default.bool,
  spellCheck: _propTypes.default.any,
  suffix: _propTypes.default.object,
  suffixSeparator: _propTypes.default.bool,
  suffixText: _propTypes.default.any,
  type: _propTypes.default.string,
  underlineFocus: _propTypes.default.bool,
  value: _propTypes.default.string
};
const defaultProps = {
  autoComplete: 'off',
  type: 'text'
};

const Input = _ref => {
  let {
    actionLink,
    autoCapitalize,
    autoComplete,
    autoCorrect,
    autoFocus,
    book,
    borderless,
    disabled,
    errorMessage,
    floating,
    focusBorderless,
    hideLabel,
    id,
    inline,
    inputRef,
    invalid,
    inverse,
    label,
    labelDescription,
    large,
    lightLabel,
    mask,
    maxLength,
    name,
    onBlur,
    onChange,
    onClear,
    onFocus,
    onKeyDown,
    placeholder,
    prefix,
    prefixSeparator,
    readOnly,
    refForFocus,
    removeMargins,
    removePrefixSpacing,
    removeSuffixSpacing,
    showFakeValuePlaceholder,
    showOverflowEllipsis,
    small,
    spellCheck,
    suffix,
    suffixSeparator,
    suffixText,
    type,
    underlineFocus,
    value
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(_FormElement.default, {
    actionLink: actionLink,
    errorMessage: errorMessage,
    hideLabel: hideLabel,
    id: id,
    inline: inline,
    invalid: invalid,
    inverse: inverse,
    label: label,
    labelDescription: labelDescription,
    large: large,
    lightLabel: lightLabel,
    small: small
  }, /*#__PURE__*/_react.default.createElement(_InputOnly.default, {
    autoCapitalize: autoCapitalize,
    autoComplete: autoComplete,
    autoCorrect: autoCorrect,
    autoFocus: autoFocus,
    book: book,
    borderless: borderless,
    disabled: disabled,
    floating: floating,
    focusBorderless: focusBorderless,
    id: id,
    inline: inline,
    inputRef: inputRef,
    invalid: invalid,
    inverse: inverse,
    large: large,
    mask: mask,
    maxLength: maxLength,
    name: name,
    onBlur: onBlur,
    onChange: onChange,
    onClear: onClear,
    onFocus: onFocus,
    onKeyDown: onKeyDown,
    placeholder: placeholder,
    prefix: prefix,
    prefixSeparator: prefixSeparator,
    readOnly: readOnly,
    refForFocus: refForFocus,
    removeMargins: removeMargins,
    removePrefixSpacing: removePrefixSpacing,
    removeSuffixSpacing: removeSuffixSpacing,
    showFakeValuePlaceholder: showFakeValuePlaceholder,
    showOverflowEllipsis: showOverflowEllipsis,
    small: small,
    spellCheck: spellCheck,
    suffix: suffix,
    suffixSeparator: suffixSeparator,
    suffixText: suffixText,
    type: type,
    underlineFocus: underlineFocus,
    value: value
  }));
};

Input.propTypes = propTypes;
Input.defaultProps = defaultProps;
var _default = Input;
exports.default = _default;