"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  isLoading: _propTypes.default.bool,
  small: _propTypes.default.bool,
  large: _propTypes.default.bool,
  primary: _propTypes.default.bool,
  secondary: _propTypes.default.bool,
  mono: _propTypes.default.bool
};

const Loader = _ref => {
  let {
    isLoading,
    styles,
    small,
    large,
    secondary,
    primary,
    mono
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", (0, _withStyles.css)(styles.loader), /*#__PURE__*/_react.default.createElement("div", (0, _withStyles.css)(styles.loader__ball, small && styles.loader__ball_small, large && styles.loader__ball_large, secondary && styles.loader__ball_secondary, primary && styles.loader__ball_primary, mono && styles.loader__ball_mono)), /*#__PURE__*/_react.default.createElement("div", (0, _withStyles.css)(styles.loader__ball, styles.loader__ball_second, small && styles.loader__ball_small, large && styles.loader__ball_large, secondary && styles.loader__ball_secondary, primary && styles.loader__ball_primary, mono && styles.loader__ball_mono)), /*#__PURE__*/_react.default.createElement("div", (0, _withStyles.css)(styles.loader__ball, styles.loader__ball_third, small && styles.loader__ball_small, large && styles.loader__ball_large, secondary && styles.loader__ball_secondary, primary && styles.loader__ball_primary, mono && styles.loader__ball_mono)));
};

Loader.propTypes = propTypes;
const bounceKeyframes = {
  '0%, 80%, 100%': {
    transform: 'scale(0)'
  },
  '40%': {
    transform: 'scale(1.0)'
  }
};
const LoaderWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    units
  } = _ref2;
  return {
    loader: {
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    },
    loader__ball: {
      width: units(1),
      height: units(1),
      margin: units(.1),
      backgroundColor: color.white,
      borderRadius: '100%',
      display: 'inline-block',
      animationName: bounceKeyframes,
      animationDuration: '1.4s',
      animationIterationCount: 'infinite',
      animationEasing: 'ease-in-out',
      animationDirection: 'both'
    },
    loader__ball_small: {
      width: units(0.5),
      height: units(0.5)
    },
    loader__ball_large: {
      width: units(2),
      height: units(2)
    },
    loader__ball_primary: {
      backgroundColor: color.primary
    },
    loader__ball_secondary: {
      backgroundColor: color.secondary
    },
    loader__ball_mono: {
      backgroundColor: color.grayDarker
    },
    loader__ball_second: {
      animationDelay: '0.16s'
    },
    loader__ball_third: {
      animationDelay: '0.32s'
    }
  };
})(Loader);
var _default = LoaderWithStyles;
exports.default = _default;