"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactGoogleMaps = require("react-google-maps");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const defaultProps = {
  center: {
    lat: -19.9322014,
    lng: -43.9246216
  },
  radius: 50,
  options: {
    fillColor: '#ee430e',
    strokeColor: '#ee430e',
    strokeWeight: 1,
    fillOpacity: .3,
    strokeOpacity: .5
  }
};

class MapCircle extends _react.Component {
  render() {
    const {
      center,
      draggable,
      editable,
      onCenterChanged,
      onClick,
      onDragEnd,
      onMouseOut,
      onMouseOver,
      onRadiusChanged,
      options,
      radius,
      removeMarker
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactGoogleMaps.Circle, {
      ref: circle => this.circle = circle,
      center: center,
      radius: radius,
      options: options,
      draggable: draggable,
      editable: editable,
      onCenterChanged: () => this.circle && onCenterChanged && onCenterChanged(this.circle.getCenter()),
      onDragEnd: () => this.circle && onDragEnd && onDragEnd(this.circle.getCenter()),
      onRadiusChanged: () => this.circle && onRadiusChanged && onRadiusChanged(this.circle.getRadius()),
      onClick: () => onClick && onClick(),
      onMouseOut: () => onMouseOut && onMouseOut(),
      onMouseOver: () => onMouseOver && onMouseOver()
    }), !removeMarker && /*#__PURE__*/_react.default.createElement(_reactGoogleMaps.Marker, {
      position: center,
      visible: false
    }));
  }

}

MapCircle.defaultProps = defaultProps;
var _default = MapCircle;
exports.default = _default;