"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactGoogleMaps = require("react-google-maps");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const defaultProps = {
  options: {
    fillColor: '#ee430e',
    strokeColor: '#ee430e',
    strokeWeight: 1,
    fillOpacity: .3,
    strokeOpacity: .5
  }
};

class MapRectangle extends _react.Component {
  render() {
    const {
      defaultBounds,
      defaultDraggable,
      defaultEditable,
      defaultOptions,
      defaultVisible,
      bounds,
      draggable,
      editable,
      options,
      visible,
      onDblClick,
      onDragEnd,
      onDragStart,
      onMouseDown,
      onMouseMove,
      onMouseOut,
      onMouseOver,
      onMouseUp,
      onRightClick,
      onBoundsChanged,
      onClick,
      onDrag,
      removeMarker
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactGoogleMaps.Rectangle, {
      ref: rectangle => this.rectangle = rectangle,
      defaultBounds: defaultBounds,
      defaultDraggable: defaultDraggable,
      defaultEditable: defaultEditable,
      defaultOptions: defaultOptions,
      defaultVisible: defaultVisible,
      bounds: bounds,
      visible: visible,
      options: options,
      draggable: draggable,
      editable: editable,
      onDragStart: () => this.rectangle && onDragStart && onDragStart(this.rectangle.getBounds()),
      onDragEnd: () => this.rectangle && onDragEnd && onDragEnd(this.rectangle.getBounds()),
      onDrag: () => this.rectangle && onDrag && onDrag(this.rectangle.getBounds()),
      onBoundsChanged: () => this.rectangle && onBoundsChanged && onBoundsChanged(this.rectangle.getBounds()),
      onDblClick: () => onDblClick && onDblClick(),
      onClick: () => onClick && onClick(),
      onMouseDown: () => onMouseDown && onMouseDown(),
      onMouseMove: () => onMouseMove && onMouseMove(),
      onMouseOut: () => onMouseOut && onMouseOut(),
      onMouseOver: () => onMouseOver && onMouseOver(),
      onMouseUp: () => onMouseUp && onMouseUp(),
      onRightClick: () => onRightClick && onRightClick()
    }), !removeMarker && /*#__PURE__*/_react.default.createElement(_reactGoogleMaps.Marker, {
      position: bounds,
      visible: false
    }));
  }

}

MapRectangle.defaultProps = defaultProps;
var _default = MapRectangle;
exports.default = _default;