"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Blanket = _interopRequireDefault(require("./Blanket"));

var _FlatButton = _interopRequireDefault(require("./FlatButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  children: _propTypes.default.any.isRequired,
  flex: _propTypes.default.bool,
  fullHeight: _propTypes.default.bool,
  fullScreen: _propTypes.default.bool,
  global: _propTypes.default.bool,
  large: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  noPadding: _propTypes.default.bool,
  onClickBlanket: _propTypes.default.func,
  onClose: _propTypes.default.func,
  removeBlanket: _propTypes.default.bool,
  removeCloseButton: _propTypes.default.bool,
  small: _propTypes.default.bool,
  visible: _propTypes.default.bool,
  xlarge: _propTypes.default.bool,
  zIndex: _propTypes.default.number
};

class Modal extends _react.Component {
  render() {
    const {
      css,
      children,
      flex,
      fullHeight,
      fullScreen,
      global,
      large,
      micro,
      noPadding,
      onClickBlanket,
      onClose,
      removeBlanket,
      removeCloseButton,
      small,
      styles,
      visible,
      xlarge,
      zIndex
    } = this.props;
    return visible ? /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement("div", css(styles.container, {
      zIndex: typeof zIndex === 'number' && zIndex
    }), /*#__PURE__*/_react.default.createElement("div", css(styles.modal, flex && styles.modal_flex, fullHeight && styles.modal_fullHeight, !fullScreen && !xlarge && !small && !large && !micro && styles.modal_default, fullScreen && styles.modal_fullScreen, micro && styles.modal_micro, small && styles.modal_small, large && styles.modal_large, xlarge && styles.modal_xlarge, noPadding && styles.noPadding), !removeCloseButton && /*#__PURE__*/_react.default.createElement("div", css(styles.closeButton), /*#__PURE__*/_react.default.createElement(_FlatButton.default, {
      transparent: true,
      icon: "error",
      onClick: () => onClose && onClose()
    })), children), (removeBlanket || !fullScreen) && /*#__PURE__*/_react.default.createElement(_Blanket.default, {
      global: global,
      visible: true,
      onClick: () => onClickBlanket ? onClickBlanket() : onClose ? onClose() : null
    }))) : null;
  }

}

const ModalWithStyles = (0, _withStyles.withStyles)(_ref => {
  let {
    breakpoint,
    color,
    units,
    radius,
    shadow
  } = _ref;
  return {
    container: {
      position: 'absolute',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      padding: 0,
      margin: 0,
      height: '100vh',
      width: '100vw',
      overflow: 'auto',
      boxSizing: 'border-box'
    },
    modal: {
      position: 'absolute',
      zIndex: 999,
      background: color.white,
      left: '50%',
      boxSizing: 'border-box',
      transform: 'translate(-50%, 0)',
      width: "calc(100% - ".concat(units(2), "px)"),
      borderRadius: radius,
      borderColor: color.gray,
      borderWidth: 1,
      borderStyle: 'solid',
      padding: units(1.5),
      marginTop: units(1.5),
      ...shadow.level2
    },
    modal_default: {
      maxWidth: units(30)
    },
    modal_flex: {
      display: 'flex',
      flexDirection: 'column'
    },
    modal_micro: {
      maxWidth: units(18)
    },
    modal_small: {
      maxWidth: units(24)
    },
    modal_large: {
      maxWidth: units(64)
    },
    modal_xlarge: {
      maxWidth: units(96)
    },
    modal_fullScreen: {
      width: 'unset',
      margin: 0,
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      transform: 'unset',
      borderRadius: 0,
      border: 0
    },
    modal_fullHeight: {
      minHeight: "calc(100% - ".concat(units(3), "px)"),
      [breakpoint.large]: {
        maxHeight: "calc(100% - ".concat(units(3), "px)")
      }
    },
    closeButton: {
      position: 'absolute',
      top: units(.5),
      right: units(.5)
    },
    noPadding: {
      padding: 0
    }
  };
})(Modal);
Modal.propTypes = propTypes;
var _default = ModalWithStyles;
exports.default = _default;