"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Grid = _interopRequireDefault(require("./Grid"));

var _Cell = _interopRequireDefault(require("./Cell"));

var _Text = _interopRequireDefault(require("./Text"));

var _Title = _interopRequireDefault(require("./Title"));

var _Spacing = _interopRequireDefault(require("./Spacing"));

var _Visibility = _interopRequireDefault(require("./Visibility"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  children: _propTypes.default.any,
  description: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  inverse: _propTypes.default.bool,
  level: _propTypes.default.oneOf([1, 2, 3]),
  loading: _propTypes.default.bool,
  removeMargin: _propTypes.default.bool,
  section: _propTypes.default.string,
  title: _propTypes.default.string
};
const defaultProps = {
  level: 1,
  title: ''
};

const PageHeader = _ref => {
  let {
    children,
    css,
    description,
    inverse,
    level,
    loading,
    border,
    removeDescriptionSpacing,
    removeMargin,
    section,
    styles,
    title
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.pageHeader, border && styles.pageHeader_withBorder, removeMargin && styles.pageHeader_noMargin), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    resetSpacing: true
  }, /*#__PURE__*/_react.default.createElement(_Cell.default, {
    size: 12,
    autoOnMedium: true
  }, section && /*#__PURE__*/_react.default.createElement(_Text.default, {
    muted: true,
    small: true,
    bold: true
  }, section), /*#__PURE__*/_react.default.createElement(_Title.default, {
    title: title,
    level: level,
    noTopSpacing: section != null,
    noBottomSpacing: removeDescriptionSpacing
  }), description && typeof description === 'string' ? /*#__PURE__*/_react.default.createElement(_Text.default, {
    loading: loading
  }, description) : description), /*#__PURE__*/_react.default.createElement(_Visibility.default, {
    showIf: children !== undefined
  }, /*#__PURE__*/_react.default.createElement(_Cell.default, {
    size: 12,
    shrinkOnMedium: true
  }, /*#__PURE__*/_react.default.createElement(_Spacing.default, {
    top: 0.5
  }, children)))));
};

PageHeader.propTypes = propTypes;
PageHeader.defaultProps = defaultProps;
const PageHeaderWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    units
  } = _ref2;
  return {
    pageHeader: {
      paddingTop: units(1),
      paddingBottom: units(1),
      display: 'flex',
      marginBottom: units(1.5)
    },
    pageHeader_withBorder: {
      borderBottomColor: color.blueGray,
      borderBottomWidth: 1,
      borderBottomStyle: 'solid',
      marginBottom: units(2)
    },
    pageHeader_noMargin: {
      marginBottom: 0
    }
  };
})(PageHeader);
var _default = PageHeaderWithStyles;
exports.default = _default;