"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrivateRoute = void 0;

var _reactRouterDom = require("react-router-dom");

var _reactRedux = require("react-redux");

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

class PrivateRoute extends _react.Component {
  handleUnauthorizedAccess() {
    console.log(window.location);
    const {
      href
    } = window.location;
    return /*#__PURE__*/_react.default.createElement(_reactRouterDom.Route, {
      render: () => window.location = "http://auth.localcinnecta.com/signin?continue=".concat(href)
    });
  }

  render() {
    const {
      component: Component,
      render,
      authenticated,
      loading,
      location,
      ...rest
    } = this.props;

    if (loading) {
      return /*#__PURE__*/_react.default.createElement(_reactRouterDom.Route, _extends({}, rest, {
        component: Loading
      }));
    }

    let renderMethod = render;

    if (render && !authenticated) {
      renderMethod = () => this.handleUnauthorizedAccess(location);
    }

    return /*#__PURE__*/_react.default.createElement(_reactRouterDom.Route, _extends({}, rest, {
      render: render ? renderMethod : props => authenticated ? /*#__PURE__*/_react.default.createElement(Component, props) : this.handleUnauthorizedAccess(location)
    }));
  }

}

const Loading = () => /*#__PURE__*/_react.default.createElement("div", null, "Autenticando...");

const mapStateToProps = state => {
  const {
    authenticated,
    loading
  } = state.auth;
  return {
    authenticated,
    loading
  };
};

const ConnectedPrivateRoute = (0, _reactRedux.connect)(mapStateToProps)(PrivateRoute);
exports.PrivateRoute = ConnectedPrivateRoute;