"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  large: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  small: _propTypes.default.bool,
  square: _propTypes.default.string,
  progression: _propTypes.default.number
};

const ProgressBar = _ref => {
  let {
    css,
    large,
    loading,
    micro,
    small,
    square,
    progression,
    styles
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.container), /*#__PURE__*/_react.default.createElement("div", css(styles.progression), "".concat(progression, "%")), /*#__PURE__*/_react.default.createElement("div", css(styles.progressBar, styles.outsideProgressBar, large && styles.outsideProgressBar_large, micro && styles.outsideProgressBar_micro, small && styles.outsideProgressBar_small, square && styles.progressBar_square, !micro && !small && !large && styles.outsideProgressBar_medium), /*#__PURE__*/_react.default.createElement("div", css(styles.progressBar, styles.insideProgressBar, square && styles.progressBar_square, loading && styles.insideProgressBar_loading, {
    width: "".concat(progression, "%")
  }))));
};

ProgressBar.propTypes = propTypes;
const ProgressBarWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    units,
    radius
  } = _ref2;
  return {
    container: {
      display: 'inline-block'
    },
    progressBar: {
      borderRadius: units(0.5)
    },
    outsideProgressBar: {
      backgroundColor: '#e5e5e5',
      position: 'relative',
      boxShadow: 'inset 1px 2px 5px #c1c1c1'
    },
    insideProgressBar: {
      backgroundColor: color.secondary,
      backgroundImage: 'linear-gradient(to right, #055bad , #00d4ff)',
      height: '100%',
      position: 'absolute'
    },
    outsideProgressBar_micro: {
      width: units(5),
      height: units(0.8)
    },
    outsideProgressBar_small: {
      width: units(10),
      height: units(0.8)
    },
    outsideProgressBar_medium: {
      width: units(15),
      height: units(0.8)
    },
    outsideProgressBar_large: {
      width: units(20),
      height: units(0.8)
    },
    progressBar_square: {
      borderRadius: radius * 0.5
    },
    insideProgressBar_loading: {
      backgroundColor: color.blueGray,
      backgroundImage: "None"
    },
    progression: {
      textAlign: 'right',
      marginBottom: units(0.1),
      fontSize: units(1.2)
    }
  };
})(ProgressBar);
var _default = ProgressBarWithStyles;
exports.default = _default;