"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormElement = _interopRequireDefault(require("./FormElement"));

var _SelectOnly = _interopRequireDefault(require("./SelectOnly"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = {
  actionLink: _propTypes.default.string,
  autoCapitalize: _propTypes.default.bool,
  autoComplete: _propTypes.default.oneOf(['off', 'on']),
  autoCorrect: _propTypes.default.any,
  autoFocus: _propTypes.default.bool,
  book: _propTypes.default.bool,
  borderless: _propTypes.default.bool,
  cacheOptions: _propTypes.default.bool,
  clearable: _propTypes.default.bool,
  closeMenuOnSelect: _propTypes.default.bool,
  defaultOptions: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.array]),
  defaultValue: _propTypes.default.object,
  disabled: _propTypes.default.bool,
  errorMessage: _propTypes.default.any,
  focusBorderless: _propTypes.default.bool,
  getOptionLabel: _propTypes.default.func,
  getOptionValue: _propTypes.default.func,
  hideLabel: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  inputRef: _propTypes.default.func,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  label: _propTypes.default.string,
  labelDescription: _propTypes.default.string,
  large: _propTypes.default.bool,
  lightLabel: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  loadingMessage: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  loadOptions: _propTypes.default.func,
  mask: _propTypes.default.func,
  maxLength: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  multiple: _propTypes.default.bool,
  name: _propTypes.default.string.isRequired,
  noOptionsMessage: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onClear: _propTypes.default.func,
  onCreateOption: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  onInputChange: _propTypes.default.func,
  onKeyDown: _propTypes.default.func,
  options: _propTypes.default.array,
  placeholder: _propTypes.default.string,
  prefix: _propTypes.default.object,
  prefixSeparator: _propTypes.default.bool,
  readOnly: _propTypes.default.bool,
  refForFocus: _propTypes.default.func,
  removeMargins: _propTypes.default.bool,
  removePrefixSpacing: _propTypes.default.bool,
  removeSuffixSpacing: _propTypes.default.bool,
  shimmer: _propTypes.default.bool,
  showFakeValuePlaceholder: _propTypes.default.bool,
  showOverflowEllipsis: _propTypes.default.bool,
  small: _propTypes.default.bool,
  spellCheck: _propTypes.default.any,
  suffix: _propTypes.default.object,
  suffixSeparator: _propTypes.default.bool,
  suffixText: _propTypes.default.any,
  type: _propTypes.default.string,
  underlineFocus: _propTypes.default.bool,
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array, _propTypes.default.object])
};
const defaultProps = {
  autoComplete: 'off',
  type: 'text',
  closeMenuOnSelect: true
};

const Select = _ref => {
  let {
    actionLink,
    autoCapitalize,
    autoComplete,
    autoCorrect,
    autoFocus,
    book,
    borderless,
    cacheOptions,
    clearable,
    closeMenuOnSelect,
    defaultOptions,
    defaultValue,
    disabled,
    errorMessage,
    focusBorderless,
    getOptionLabel,
    getOptionValue,
    hideLabel,
    id,
    inline,
    inputRef,
    invalid,
    inverse,
    label,
    labelDescription,
    large,
    lightLabel,
    loading,
    loadingMessage,
    loadOptions,
    mask,
    maxLength,
    multiple,
    name,
    noOptionsMessage,
    onBlur,
    onChange,
    onClear,
    onCreateOption,
    onFocus,
    onInputChange,
    onKeyDown,
    options,
    placeholder,
    prefix,
    prefixSeparator,
    readOnly,
    refForFocus,
    removeMargins,
    removePrefixSpacing,
    removeSuffixSpacing,
    shimmer,
    showFakeValuePlaceholder,
    showOverflowEllipsis,
    small,
    spellCheck,
    suffix,
    suffixSeparator,
    suffixText,
    type,
    underlineFocus,
    value
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(_FormElement.default, {
    actionLink: actionLink,
    errorMessage: errorMessage,
    hideLabel: hideLabel,
    id: id,
    inline: inline,
    invalid: invalid,
    inverse: inverse,
    label: label,
    labelDescription: labelDescription,
    large: large,
    lightLabel: lightLabel,
    small: small
  }, /*#__PURE__*/_react.default.createElement(_SelectOnly.default, {
    autoCapitalize: autoCapitalize,
    autoComplete: autoComplete,
    autoCorrect: autoCorrect,
    autoFocus: autoFocus,
    book: book,
    borderless: borderless,
    cacheOptions: cacheOptions,
    clearable: clearable,
    closeMenuOnSelect: closeMenuOnSelect,
    defaultOptions: defaultOptions,
    defaultValue: defaultValue,
    disabled: disabled,
    focusBorderless: focusBorderless,
    getOptionLabel: getOptionLabel,
    getOptionValue: getOptionValue,
    id: id,
    inline: inline,
    inputRef: inputRef,
    invalid: invalid,
    inverse: inverse,
    large: large,
    loading: loading,
    loadingMessage: loadingMessage,
    loadOptions: loadOptions,
    mask: mask,
    maxLength: maxLength,
    multiple: multiple,
    name: name,
    noOptionsMessage: noOptionsMessage,
    onBlur: onBlur,
    onChange: onChange,
    onClear: onClear,
    onCreateOption: onCreateOption,
    onFocus: onFocus,
    onInputChange: onInputChange,
    onKeyDown: onKeyDown,
    options: options,
    placeholder: placeholder,
    prefix: prefix,
    prefixSeparator: prefixSeparator,
    readOnly: readOnly,
    refForFocus: refForFocus,
    removeMargins: removeMargins,
    removePrefixSpacing: removePrefixSpacing,
    removeSuffixSpacing: removeSuffixSpacing,
    shimmer: shimmer,
    showFakeValuePlaceholder: showFakeValuePlaceholder,
    showOverflowEllipsis: showOverflowEllipsis,
    small: small,
    spellCheck: spellCheck,
    suffix: suffix,
    suffixSeparator: suffixSeparator,
    suffixText: suffixText,
    type: type,
    underlineFocus: underlineFocus,
    value: value
  }));
};

Select.propTypes = propTypes;
Select.defaultProps = defaultProps;
var _default = Select;
exports.default = _default;