"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactSelect = _interopRequireDefault(require("react-select"));

var _Creatable = _interopRequireDefault(require("react-select/lib/Creatable"));

var _Async = _interopRequireDefault(require("react-select/lib/Async"));

var _AsyncCreatable = _interopRequireDefault(require("react-select/lib/AsyncCreatable"));

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

var _reactWithStyles = require("react-with-styles");

var _withStyles = require("../helpers/withStyles");

var _CinnectaTheme = _interopRequireDefault(require("../themes/CinnectaTheme"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  actionLink: _propTypes.default.string,
  autoCapitalize: _propTypes.default.bool,
  autoComplete: _propTypes.default.oneOf(['off', 'on']),
  autoCorrect: _propTypes.default.any,
  autoFocus: _propTypes.default.bool,
  book: _propTypes.default.bool,
  borderless: _propTypes.default.bool,
  cacheOptions: _propTypes.default.bool,
  clearable: _propTypes.default.bool,
  closeMenuOnSelect: _propTypes.default.bool,
  defaultOptions: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.array]),
  defaultValue: _propTypes.default.object,
  disabled: _propTypes.default.bool,
  flat: _propTypes.default.bool,
  floating: _propTypes.default.bool,
  focusBorderless: _propTypes.default.bool,
  getOptionLabel: _propTypes.default.func,
  getOptionValue: _propTypes.default.func,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  inputRef: _propTypes.default.func,
  insidePrefix: _propTypes.default.bool,
  insideSuffix: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  loadOptions: _propTypes.default.func,
  large: _propTypes.default.bool,
  loadingMessage: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  mask: _propTypes.default.func,
  maxLength: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  multiple: _propTypes.default.bool,
  name: _propTypes.default.string.isRequired,
  noOptionsMessage: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onClear: _propTypes.default.func,
  onCreateOption: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  onInputChange: _propTypes.default.func,
  onKeyDown: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  prefix: _propTypes.default.object,
  prefixSeparator: _propTypes.default.bool,
  readOnly: _propTypes.default.bool,
  refForFocus: _propTypes.default.func,
  removeMargins: _propTypes.default.bool,
  removePrefixSpacing: _propTypes.default.bool,
  removeSuffixSpacing: _propTypes.default.bool,
  right: _propTypes.default.bool,
  shimmer: _propTypes.default.bool,
  showFakeValuePlaceholder: _propTypes.default.bool,
  showOverflowEllipsis: _propTypes.default.bool,
  small: _propTypes.default.bool,
  spellCheck: _propTypes.default.any,
  suffix: _propTypes.default.object,
  suffixSeparator: _propTypes.default.bool,
  suffixText: _propTypes.default.any,
  type: _propTypes.default.string,
  underlineFocus: _propTypes.default.bool,
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array, _propTypes.default.object])
};
const defaultProps = {
  options: [],
  placeholder: 'Selecione...',
  clearable: false,
  closeMenuOnSelect: true,
  noOptionsMessage: 'Sem opções...',
  loadingMessage: 'Buscando...'
};
const selectStyles = {
  option: (base, state) => ({
    //...base,
    appearance: 'none',
    borderWidth: 0,
    height: _CinnectaTheme.default.units(2),
    paddingTop: _CinnectaTheme.default.units(0.25),
    paddingRight: _CinnectaTheme.default.units(0.75),
    paddingBottom: _CinnectaTheme.default.units(0.25),
    paddingLeft: _CinnectaTheme.default.units(0.75),
    borderRadius: _CinnectaTheme.default.radius,
    fontSize: _CinnectaTheme.default.units(0.95),
    display: 'flex',
    alignItems: 'center',
    outline: 0,
    position: 'relative',
    margin: 0,
    fontWeight: 500,
    fontFamily: _CinnectaTheme.default.font.default,
    cursor: 'pointer',
    boxSizing: 'border-box',
    background: state.isSelected ? _CinnectaTheme.default.color.blueGrayDark : state.isFocused ? _CinnectaTheme.default.color.grayLight : _CinnectaTheme.default.color.white,
    color: state.isSelected ? _CinnectaTheme.default.color.white : _CinnectaTheme.default.color.primary,
    whiteSpace: 'nowrap',
    '&:hover': {
      background: !state.isSelected && _CinnectaTheme.default.color.blueGrayLight
    },
    '&:active': {
      background: !state.isSelected && _CinnectaTheme.default.color.blueGray
    }
  }),
  menu: () => ({
    position: 'absolute',
    marginTop: _CinnectaTheme.default.units(.25),
    top: '100%',
    backgroundColor: _CinnectaTheme.default.color.white,
    boxShadow: "0 ".concat(_CinnectaTheme.default.units(0.5), " ").concat(_CinnectaTheme.default.units(0.75), " ").concat(_CinnectaTheme.default.units(-0.45), " ").concat(_CinnectaTheme.default.color.shadow),
    padding: _CinnectaTheme.default.units(0.5),
    borderRadius: _CinnectaTheme.default.radius,
    borderWidth: 1,
    borderStyle: 'solid',
    borderColor: _CinnectaTheme.default.color.blueGrayLight,
    zIndex: 2,
    minWidth: '100%',
    boxSizing: 'border-box'
  }),
  menuList: base => ({ ...base,
    padding: 0
  }),
  control: () => ({
    width: '100%',
    display: 'flex',
    alignItems: 'center',
    flex: 1,
    flexWrap: 'wrap',
    position: 'relative',
    boxSizing: 'border-box'
  }),
  container: () => ({
    width: '100%'
  }),
  indicatorSeparator: () => ({
    display: 'none'
  }),
  dropdownIndicator: (base, state) => ({ ...base,
    fill: _CinnectaTheme.default.color.grayDark,
    color: state.isFocused ? _CinnectaTheme.default.color.grayDarker : _CinnectaTheme.default.color.grayDark,
    opacity: 1,
    width: 32,
    '&:hover': {
      color: _CinnectaTheme.default.color.grayDarker
    }
  }),
  singleValue: (base, state) => ({ ...base,
    transition: 'opacity 300ms',
    color: _CinnectaTheme.default.color.grayDarker,
    position: 'static',
    transform: 'none',
    maxWidth: '100%',
    order: 2
  }),
  input: base => ({ ...base,
    color: _CinnectaTheme.default.color.grayDarker,
    margin: 0,
    padding: 0,
    order: 1
  }),
  placeholder: base => ({ ...base,
    color: _CinnectaTheme.default.input.placeholderColor,
    position: 'static',
    transform: 'none',
    order: 2
  }),
  multiValue: base => ({ ...base,
    background: _CinnectaTheme.default.color.gray,
    color: _CinnectaTheme.default.color.grayDarker
  }),
  multiValueRemove: base => ({ ...base,
    borderRadius: '50%',
    height: 18,
    width: 18,
    padding: 0,
    marginTop: 2,
    marginLeft: 4,
    marginRight: 2,
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    color: _CinnectaTheme.default.color.grayDarker,
    fill: _CinnectaTheme.default.color.grayDarker,
    '&:hover': {
      background: _CinnectaTheme.default.color.shadowWeak,
      color: _CinnectaTheme.default.color.grayDarker,
      fill: _CinnectaTheme.default.color.grayDarker
    }
  }),
  multiValueLabel: base => ({ ...base,
    color: _CinnectaTheme.default.color.grayDarker
  })
};

const SelectOnly = _ref => {
  let {
    autocomplete,
    autoFocus,
    book,
    borderless,
    cacheOptions,
    clearable,
    css,
    closeMenuOnSelect,
    defaultOptions,
    defaultValue,
    disabled,
    flat,
    floating,
    focusBorderless,
    getOptionLabel,
    getOptionValue,
    id,
    inline,
    inputRef,
    insidePrefix,
    insideSuffix,
    invalid,
    inverse,
    large,
    loading,
    loadingMessage,
    loadOptions,
    multiple,
    name,
    noOptionsMessage,
    onBlur,
    onChange,
    onClear,
    onCreateOption,
    onFocus,
    onInputChange,
    onKeyDown,
    options,
    placeholder,
    prefix,
    prefixSeparator,
    readOnly,
    refForFocus,
    removeMargins,
    removePrefixSpacing,
    removeSuffixSpacing,
    shimmer,
    showFakeValuePlaceholder,
    showOverflowEllipsis,
    small,
    spellCheck,
    styles,
    suffix,
    suffixSeparator,
    suffixText,
    underlineFocus,
    value
  } = _ref;
  const selectProps = {
    closeMenuOnSelect: closeMenuOnSelect,
    defaultValue: defaultValue,
    isDisabled: disabled,
    isLoading: loading,
    isClearable: clearable,
    isMulti: multiple,
    isSearchable: autocomplete,
    getOptionLabel: getOptionLabel,
    getOptionValue: getOptionValue,
    name: name,
    noOptionsMessage: () => noOptionsMessage,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    onInputChange: onInputChange,
    onKeyDown: onKeyDown,
    options: options,
    loadingMessage: () => loadingMessage,
    placeholder: placeholder,
    styles: selectStyles,
    theme: theme => ({ ...theme,
      width: '100%',
      borderRadius: 0,
      colors: { ...theme.colors,
        text: 'orangered',
        primary25: _CinnectaTheme.default.color.blueGray,
        primary: _CinnectaTheme.default.color.primary
      }
    }),
    value: value
  };

  const selectComponent = () => {
    if (!!loadOptions) {
      if (!!onCreateOption) {
        return /*#__PURE__*/_react.default.createElement(_AsyncCreatable.default, _extends({}, selectProps, {
          cacheOptions: cacheOptions,
          defaultOptions: defaultOptions,
          formatCreateLabel: value => "Criar \"".concat(value, "\""),
          isValidNewOption: (inputValue, selectValue, selectOptions) => {
            const isNotDuplicated = !selectOptions.map(option => option.label).includes(inputValue);
            const isNotEmpty = inputValue !== '';
            return isNotEmpty && isNotDuplicated;
          },
          loadOptions: loadOptions,
          onCreateOption: onCreateOption
        }));
      } else {
        return /*#__PURE__*/_react.default.createElement(_Async.default, _extends({}, selectProps, {
          cacheOptions: cacheOptions,
          defaultOptions: defaultOptions,
          loadOptions: loadOptions
        }));
      }
    } else {
      if (!!onCreateOption) {
        return /*#__PURE__*/_react.default.createElement(_Creatable.default, _extends({}, selectProps, {
          formatCreateLabel: value => "Criar \"".concat(value, "\""),
          isValidNewOption: (inputValue, selectValue, selectOptions) => {
            const isNotDuplicated = !selectOptions.map(option => option.label).includes(inputValue);
            const isNotEmpty = inputValue !== '';
            return isNotEmpty && isNotDuplicated;
          },
          onCreateOption: onCreateOption
        }));
      } else {
        return /*#__PURE__*/_react.default.createElement(_reactSelect.default, selectProps);
      }
    }
  };

  return /*#__PURE__*/_react.default.createElement("div", css(styles.selectOnly, !inline && styles.block, borderless && styles.borderless, disabled && styles.selectOnly_disabled, invalid && styles.selectOnly_invalid, inverse && styles.selectOnly_inverse, flat && styles.selectOnly_flat, floating && styles.selectOnly_floating, focusBorderless && styles.selectOnly_focusBorderless, loading && styles.selectOnly_disabled, small && styles.selectOnly_small, removeMargins && styles.noMargin, insidePrefix && styles.selectOnly_insidePrefix, insideSuffix && styles.selectOnly_insideSuffix), shimmer && /*#__PURE__*/_react.default.createElement("div", css(styles.shimmer), /*#__PURE__*/_react.default.createElement(_Shimmer.default, {
    width: "100%",
    height: "100%"
  })), prefix && /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement("div", css(styles.selectOnly__prefix, removePrefixSpacing && styles.noPadding), prefix), prefixSeparator && /*#__PURE__*/_react.default.createElement("div", css(styles.separator, styles.separator_prefix, removePrefixSpacing && styles.noMargin))), selectComponent(), suffix && /*#__PURE__*/_react.default.createElement(_react.Fragment, null, suffixSeparator && /*#__PURE__*/_react.default.createElement("div", css(styles.separator, styles.separator_suffix, removeSuffixSpacing && styles.noMargin)), /*#__PURE__*/_react.default.createElement("div", css(styles.selectOnly__suffix, removeSuffixSpacing && styles.noPadding), suffix)));
};

SelectOnly.propTypes = propTypes;
SelectOnly.defaultProps = defaultProps;
const SelectOnlyWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    input,
    color,
    shadow
  } = _ref2;
  return {
    selectOnly: { ...input.default,
      display: 'inline-flex',
      position: 'relative',
      flexWrap: 'nowrap',
      alignItems: 'center',
      boxSizing: 'border-box',
      minHeight: 40,
      ':focus-within': { ...input.focus
      }
    },
    selectOnly_inverse: {
      background: color.white
    },
    selectOnly_focusBorderless: {
      ':focus-within': {
        borderWidth: 0
      }
    },
    selectOnly_insidePrefix: {
      height: 38
    },
    selectOnly_insideSuffix: {
      height: 38
    },
    selectOnly_disabled: { ...input.disabled
    },
    selectOnly_invalid: { ...input.invalid
    },
    selectOnly_flat: {
      borderColor: color.blueGray,
      background: color.white
    },
    selectOnly_floating: { ...shadow.level1,
      background: color.white,
      borderColor: color.white
    },
    selectOnly_small: { ...input.small
    },
    noMargin: {
      marginTop: 0,
      marginRight: 0,
      marginBottom: 0,
      marginLeft: 0
    },
    noPadding: {
      paddingTop: 0,
      paddingRight: 0,
      paddingBottom: 0,
      paddingLeft: 0
    },
    selectOnly__input: { ...input.default,
      border: 0,
      margin: 0,
      background: color.transparent,
      width: '100%',
      height: 'auto',
      paddingTop: input.verticalPadding,
      paddingRight: input.horizontalPadding,
      paddingBottom: input.verticalPadding,
      paddingLeft: input.horizontalPadding,
      boxSizing: 'border-box',
      '::-ms-clear': {
        display: 'none'
      },
      ':focus': {
        outline: 'none',
        boxShadow: 'none',
        border: 0
      }
    },
    selectOnly__input_ellipsis: {
      textOverflow: 'ellipsis'
    },
    selectOnly__input_defaultPlaceholder: {
      '::placeholder': {
        color: input.placeholderColor,
        opacity: 1
      }
    },
    selectOnly__input_fakeValuePlaceholder: {
      '::placeholder': {
        color: input.color,
        opacity: 1
      }
    },
    selectOnly__input_inversePlaceholder: {
      '::placeholder': {
        color: color.white,
        opacity: 1
      }
    },
    selectOnly__prefix: {
      paddingLeft: input.horizontalPadding,
      flexShrink: 0
    },
    selectOnly__suffix: {
      paddingRight: input.horizontalPadding,
      flexShrink: 0
    },
    separator: {
      width: 1,
      height: 24,
      background: color.gray,
      flexShrink: 0
    },
    separator_prefix: {
      marginLeft: input.horizontalPadding
    },
    separator_suffix: {
      marginRight: input.horizontalPadding
    },
    block: {
      display: 'flex',
      width: '100%'
    },
    borderless: {
      borderColor: input.background
    },
    shimmer: {
      position: 'absolute',
      width: '100%',
      height: '100%',
      zIndex: 2,
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    }
  };
})(SelectOnly);
var _default = SelectOnlyWithStyles;
exports.default = _default;