"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const Separator = _ref => {
  let {
    children,
    css,
    largeSpacing,
    noSpacing,
    smallSpacing,
    styles,
    vertical
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.separator, vertical ? styles.separator_vertical : styles.separator_horizontal, smallSpacing && (vertical ? styles.separator_vertical_smallSpacing : styles.separator_horizontal_smallSpacing), largeSpacing && (vertical ? styles.separator_vertical_largeSpacing : styles.separator_horizontal_largeSpacing), noSpacing && styles.separator_noSpacing), /*#__PURE__*/_react.default.createElement("div", css(vertical ? styles.separator__line_vertical : styles.separator__line)), children && /*#__PURE__*/_react.default.createElement("div", css(vertical ? styles.separator__content_vertical : styles.separator__content), children), /*#__PURE__*/_react.default.createElement("div", css(vertical ? styles.separator__line_vertical : styles.separator__line)));
};

const SeparatorWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    units
  } = _ref2;
  return {
    separator: {
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      color: color.grayDark
    },
    separator_horizontal: {
      flexDirection: 'row',
      width: '100%',
      marginTop: units(2),
      marginBottom: units(2)
    },
    separator_vertical: {
      height: '100%',
      flexDirection: 'column',
      marginLeft: units(2),
      marginRight: units(2)
    },
    separator_noSpacing: {
      marginTop: 0,
      marginRight: 0,
      marginBottom: 0,
      marginLeft: 0
    },
    separator_horizontal_smallSpacing: {
      marginTop: units(1),
      marginBottom: units(1)
    },
    separator_horizontal_largeSpacing: {
      marginTop: units(3),
      marginBottom: units(3)
    },
    separator_vertical_smallSpacing: {
      marginLeft: units(1),
      marginLeft: units(1)
    },
    separator_vertical_largeSpacing: {
      marginLeft: units(3),
      marginLeft: units(3)
    },
    separator__line: {
      flex: 1,
      borderBottomWidth: 1,
      borderBottomStyle: 'solid',
      borderBottomColor: color.gray
    },
    separator__line_vertical: {
      flex: 1,
      borderLeftWidth: 1,
      borderLeftStyle: 'solid',
      borderLeftColor: color.gray
    },
    separator__content: {
      paddingLeft: units(1),
      paddingRight: units(1)
    },
    separator__content_vertical: {
      paddingTop: units(1),
      paddingTop: units(1)
    }
  };
})(Separator);
var _default = SeparatorWithStyles;
exports.default = _default;