"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _CinnectaTheme = _interopRequireDefault(require("../themes/CinnectaTheme"));

var _Responsive = require("./Responsive");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const propTypes = {
  bottom: _propTypes.default.number,
  bottomLargeAndAbove: _propTypes.default.number,
  bottomMediumAndAbove: _propTypes.default.number,
  children: _propTypes.default.any,
  horizontal: _propTypes.default.number,
  horizontalLargeAndAbove: _propTypes.default.number,
  horizontalMediumAndAbove: _propTypes.default.number,
  inline: _propTypes.default.bool,
  inside: _propTypes.default.bool,
  left: _propTypes.default.number,
  leftLargeAndAbove: _propTypes.default.number,
  leftMediumAndAbove: _propTypes.default.number,
  right: _propTypes.default.number,
  rightLargeAndAbove: _propTypes.default.number,
  rightMediumAndAbove: _propTypes.default.number,
  top: _propTypes.default.number,
  topLargeAndAbove: _propTypes.default.number,
  topMediumAndAbove: _propTypes.default.number,
  vertical: _propTypes.default.number,
  verticalLargeAndAbove: _propTypes.default.number,
  verticalMediumAndAbove: _propTypes.default.number,
  isGreaterThan: _propTypes.default.func
};

class Spacing extends _react.Component {
  render() {
    const {
      bottom,
      bottomLargeAndAbove,
      bottomMediumAndAbove,
      children,
      horizontal,
      horizontalLargeAndAbove,
      horizontalMediumAndAbove,
      inline,
      inside,
      left,
      leftLargeAndAbove,
      leftMediumAndAbove,
      right,
      rightLargeAndAbove,
      rightMediumAndAbove,
      top,
      topLargeAndAbove,
      topMediumAndAbove,
      vertical,
      verticalLargeAndAbove,
      verticalMediumAndAbove,
      isGreaterThan
    } = this.props;

    const getTopMargin = () => {
      if ((topLargeAndAbove != null || verticalLargeAndAbove != null) && isGreaterThan('large')) {
        return topLargeAndAbove || verticalLargeAndAbove;
      } else if ((topMediumAndAbove != null || verticalMediumAndAbove != null) && isGreaterThan('medium')) {
        return topMediumAndAbove || verticalMediumAndAbove;
      } else {
        return top || vertical;
      }
    };

    const getRightMargin = () => {
      if ((rightLargeAndAbove != null || horizontalLargeAndAbove != null) && isGreaterThan('large')) {
        return rightLargeAndAbove || horizontalLargeAndAbove;
      } else if ((rightMediumAndAbove != null || horizontalMediumAndAbove != null) && isGreaterThan('medium')) {
        return rightMediumAndAbove || horizontalMediumAndAbove;
      } else {
        return right || horizontal;
      }
    };

    const getBottomMargin = () => {
      if ((bottomLargeAndAbove != null || verticalLargeAndAbove != null) && isGreaterThan('large')) {
        return bottomLargeAndAbove || verticalLargeAndAbove;
      } else if ((bottomMediumAndAbove != null || verticalMediumAndAbove != null) && isGreaterThan('medium')) {
        return bottomMediumAndAbove || verticalMediumAndAbove;
      } else {
        return bottom || vertical;
      }
    };

    const getLeftMargin = () => {
      if ((leftLargeAndAbove != null || horizontalLargeAndAbove != null) && isGreaterThan('large')) {
        return leftLargeAndAbove || horizontalLargeAndAbove;
      } else if ((leftMediumAndAbove != null || horizontalMediumAndAbove != null) && isGreaterThan('medium')) {
        return leftMediumAndAbove || horizontalMediumAndAbove;
      } else {
        return left || horizontal;
      }
    };

    const topMargin = getTopMargin();
    const rightMargin = getRightMargin();
    const bottomMargin = getBottomMargin();
    const leftMargin = getLeftMargin();
    return inline ? /*#__PURE__*/_react.default.createElement("span", (0, _withStyles.css)({
      [inside ? 'paddingTop' : 'marginTop']: topMargin ? topMargin * _CinnectaTheme.default.unit : null,
      [inside ? 'paddingRight' : 'marginRight']: rightMargin ? rightMargin * _CinnectaTheme.default.unit : null,
      [inside ? 'paddingBottom' : 'marginBottom']: bottomMargin ? bottomMargin * _CinnectaTheme.default.unit : null,
      [inside ? 'paddingLeft' : 'marginLeft']: leftMargin ? leftMargin * _CinnectaTheme.default.unit : null,
      display: 'inline-block'
    }), children) : /*#__PURE__*/_react.default.createElement("div", (0, _withStyles.css)({
      [inside ? 'paddingTop' : 'marginTop']: topMargin ? topMargin * _CinnectaTheme.default.unit : null,
      [inside ? 'paddingRight' : 'marginRight']: rightMargin ? rightMargin * _CinnectaTheme.default.unit : null,
      [inside ? 'paddingBottom' : 'marginBottom']: bottomMargin ? bottomMargin * _CinnectaTheme.default.unit : null,
      [inside ? 'paddingLeft' : 'marginLeft']: leftMargin ? leftMargin * _CinnectaTheme.default.unit : null,
      width: '100%'
    }), children);
  }

}

Spacing.propTypes = propTypes;
const SpacingWithBreakpoints = (0, _Responsive.withBreakpoints)(Spacing);
var _default = SpacingWithBreakpoints;
exports.default = _default;