"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  micro: _propTypes.default.bool,
  small: _propTypes.default.bool,
  large: _propTypes.default.bool,
  primary: _propTypes.default.bool,
  secondary: _propTypes.default.bool,
  fast: _propTypes.default.bool,
  slow: _propTypes.default.bool
};

const Spinner = _ref => {
  let {
    micro,
    small,
    large,
    primary,
    secondary,
    fast,
    slow,
    css,
    styles
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.spinner, micro && styles.spinner_micro, small && styles.spinner_small, large && styles.spinner_large, primary && styles.spinner_primary, secondary && styles.spinner_secondary, fast && styles.spinner_fast, slow && styles.spinner_slow));
};

Spinner.propTypes = propTypes;
const SpinnerWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    units,
    animation
  } = _ref2;
  return {
    spinner: {
      borderWidth: units(.2),
      borderStyle: 'solid',
      borderTopColor: color.white,
      borderRightColor: color.transparent,
      borderBottomColor: color.transparent,
      borderLeftColor: color.transparent,
      borderRadius: '50%',
      animationName: animation.spinner,
      animationDuration: '.6s',
      animationIterationCount: 'infinite',
      animationEasing: 'linear',
      width: units(2.5),
      height: units(2.5)
    },
    spinner_micro: {
      width: units(1),
      height: units(1),
      borderWidth: units(0.125)
    },
    spinner_small: {
      width: units(1.375),
      height: units(1.375),
      borderWidth: units(0.125)
    },
    spinner_large: {
      width: units(5),
      height: units(5)
    },
    spinner_primary: {
      borderTopColor: color.primary
    },
    spinner_secondary: {
      borderTopColor: color.secondary
    },
    spinner_fast: {
      animationDuration: '.3s'
    },
    spinner_slow: {
      animationDuration: '1s'
    }
  };
})(Spinner);
var _default = SpinnerWithStyles;
exports.default = _default;