"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _Text = _interopRequireDefault(require("./Text"));

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = {
  color: _propTypes.default.string,
  loading: _propTypes.default.bool,
  text: _propTypes.default.string
};

const StatusIndicator = _ref => {
  let {
    text,
    color,
    css,
    loading,
    styles
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("span", css(styles.label), /*#__PURE__*/_react.default.createElement("div", css(styles.label__color, {
    backgroundColor: color
  }), loading && /*#__PURE__*/_react.default.createElement("div", css(styles.label__color__shimmer), /*#__PURE__*/_react.default.createElement(_Shimmer.default, {
    width: "100%",
    height: "100%"
  }))), /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    shimmerWidth: "3rem",
    loading: loading
  }, text));
};

StatusIndicator.propTypes = propTypes;
const StatusIndicatorWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    animation,
    units
  } = _ref2;
  return {
    label: {
      display: 'flex',
      alignItems: 'center',
      flexShrink: 0
    },
    label__color: {
      //backgroundColor: color.blueGrayDark,
      width: 9,
      height: 9,
      borderRadius: '50%',
      marginRight: units(0.5),
      flexShrink: 0,
      position: 'relative',
      overflow: 'hidden'
    },
    label__color__shimmer: {
      display: 'flex',
      position: 'absolute',
      width: '100%',
      height: '100%',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    }
  };
})(StatusIndicator);
var _default = StatusIndicatorWithStyles;
exports.default = _default;