"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Tabs = require("./Tabs");

var _Title = _interopRequireDefault(require("./Title"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  children: _propTypes.default.any,
  level: _propTypes.default.oneOf([1, 2, 3, 4, 5, 6]),
  onActivate: _propTypes.default.func,
  tabKey: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number])
};
const defaultProps = {
  level: 3
};

class TabTitle extends _react.Component {
  render() {
    const {
      children,
      css,
      level,
      onActivate,
      styles,
      tabKey
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_Tabs.TabCustomTrigger, null, _ref => {
      let {
        activeTab,
        setActiveTab
      } = _ref;
      return /*#__PURE__*/_react.default.createElement("div", _extends({}, css(styles.tab, activeTab === tabKey && styles.tab_active), {
        onClick: () => {
          setActiveTab(tabKey);
          onActivate && onActivate(tabKey);
        }
      }), /*#__PURE__*/_react.default.createElement(_Title.default, {
        primary: activeTab === tabKey,
        level: level
      }, children));
    });
  }

}

TabTitle.propTypes = propTypes;
TabTitle.defaultProps = defaultProps;

var _default = (0, _withStyles.withStyles)(() => ({
  tab: {
    display: 'inline-block',
    marginRight: 24,
    cursor: 'pointer',
    opacity: 0.5
  },
  tab_active: {
    opacity: '1'
  }
}))(TabTitle);

exports.default = _default;