"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Loader = _interopRequireDefault(require("./Loader"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  loading: _propTypes.default.bool,
  header: _propTypes.default.array,
  body: _propTypes.default.array
};

const Table = _ref => {
  let {
    css,
    loading,
    header,
    body,
    styles
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.table_container), /*#__PURE__*/_react.default.createElement("div", css(styles.flex_table), header.map(column => {
    return /*#__PURE__*/_react.default.createElement("div", css(styles.flex_row, styles.header), column);
  })), loading ? /*#__PURE__*/_react.default.createElement("div", css(styles.flex_loading), /*#__PURE__*/_react.default.createElement(_Loader.default, {
    primary: true
  })) : body.map(line => {
    return /*#__PURE__*/_react.default.createElement("div", css(styles.flex_table), line.map(column => {
      return /*#__PURE__*/_react.default.createElement("div", css(styles.flex_row), column);
    }));
  }));
};

Table.propTypes = propTypes;
const TableWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    color,
    units,
    font,
    breakpoint
  } = _ref2;
  return {
    table_container: {
      display: 'block',
      margin: 'auto',
      width: '90%',
      fontFamily: font.default
    },
    header: {
      ":last-child": {
        color: color.shadowStronger
      }
    },
    flex_table: {
      display: 'flex',
      flexDirection: 'row',
      flexWrap: "wrap",
      transitionDuration: '0.5s',
      ":nth-child(1)": {
        backgroundColor: '#edf1f5'
      }
    },
    flex_row: {
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      width: 'calc(100% / 4)',
      textAlign: 'center',
      // padding: '0.5em 0.5em', //Padding e border right/left faz com que não caiba a conta certinha do width.
      paddingTop: '0.5em',
      paddingBottom: '0.5em',
      [breakpoint.medium]: {
        width: 'calc(100% / 3)',
        ':nth-child(1)': {
          width: '100%',
          paddingTop: '1.5em',
          paddingBottom: '1.5em'
        }
      },
      [breakpoint.small]: {
        borderBottom: 0,
        width: '100%',
        ':nth-child(1)': {
          borderBottom: 'solid 1px #d9d9d9',
          width: '100%'
        }
      }
    },
    flex_loading: {
      width: '100%',
      padding: '0.5em 0.5em'
    }
  };
})(Table);
var _default = TableWithStyles;
exports.default = _default;