"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tabs = exports.TabCustomTrigger = exports.TabButton = exports.Tab = void 0;

var _react = _interopRequireWildcard(require("react"));

var _TabButton = _interopRequireDefault(require("./TabButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const TabContext = /*#__PURE__*/_react.default.createContext({
  activeTab: null,
  setActiveTab: () => {}
});

class Tabs extends _react.Component {
  constructor(props) {
    super(props);

    this.setActiveTab = tab => {
      this.setState({
        activeTab: tab
      });
    };

    this.state = {
      activeTab: null,
      setActiveTab: this.setActiveTab
    };
  }

  componentDidMount() {
    const {
      initialTab
    } = this.props;

    if (initialTab != null) {
      this.setActiveTab(initialTab);
    }
  }

  render() {
    const {
      children
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(TabContext.Provider, {
      value: this.state
    }, children);
  }

}

exports.Tabs = Tabs;

const Tab = _ref => {
  let {
    children,
    tabKey
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(TabContext.Consumer, null, _ref2 => {
    let {
      activeTab
    } = _ref2;
    return tabKey === activeTab && children;
  });
};

exports.Tab = Tab;

const TabButton = _ref3 => {
  let {
    children,
    tabKey,
    ...props
  } = _ref3;
  return /*#__PURE__*/_react.default.createElement(TabContext.Consumer, null, _ref4 => {
    let {
      activeTab,
      setActiveTab
    } = _ref4;
    return /*#__PURE__*/_react.default.createElement(_TabButton.default, _extends({
      onClick: () => setActiveTab(tabKey),
      active: tabKey === activeTab
    }, props), children);
  });
};

exports.TabButton = TabButton;
const TabCustomTrigger = TabContext.Consumer;
exports.TabCustomTrigger = TabCustomTrigger;