"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  bold: _propTypes.default.bool,
  center: _propTypes.default.bool,
  collapsed: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  error: _propTypes.default.bool,
  inline: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  large: _propTypes.default.bool,
  light: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  mono: _propTypes.default.bool,
  muted: _propTypes.default.bool,
  negative: _propTypes.default.bool,
  nowrap: _propTypes.default.bool,
  positive: _propTypes.default.bool,
  primary: _propTypes.default.bool,
  right: _propTypes.default.bool,
  secondary: _propTypes.default.bool,
  small: _propTypes.default.bool,
  short: _propTypes.default.bool,
  shimmerHeight: _propTypes.default.string,
  shimmerWidth: _propTypes.default.string,
  tall: _propTypes.default.bool,
  children: _propTypes.default.any
};

const Text = _ref => {
  let {
    bold,
    center,
    children,
    collapsed,
    disabled,
    error,
    inline,
    inverse,
    loading,
    large,
    light,
    micro,
    mono,
    muted,
    negative,
    nowrap,
    positive,
    primary,
    right,
    secondary,
    short,
    shimmerHeight,
    shimmerWidth,
    small,
    tall,
    styles
  } = _ref;

  if (small) {
    return /*#__PURE__*/_react.default.createElement("small", (0, _withStyles.css)(styles.text, bold && styles.text_bold, center && styles.text_center, collapsed && styles.text_collapsed, disabled && styles.text_disabled, (error || negative) && styles.text_error, inverse && styles.text_inverse, large && styles.text_large, light && styles.text_light, micro && styles.text_micro, mono && styles.text_mono, muted && styles.text_muted, nowrap && styles.text_nowrap, positive && styles.text_positive, primary && styles.text_primary, right && styles.text_right, secondary && styles.text_secondary, short && styles.text_short, small && styles.text_small, tall && styles.text_tall, inline && styles.text_inline), loading ? /*#__PURE__*/_react.default.createElement(_Shimmer.default, {
      height: shimmerHeight || '1ex',
      width: shimmerWidth || '60%'
    }) : children);
  } else if (inline) {
    return /*#__PURE__*/_react.default.createElement("span", (0, _withStyles.css)(styles.text, !loading && styles.text_inline, bold && styles.text_bold, center && styles.text_center, collapsed && styles.text_collapsed, (error || negative) && styles.text_error, disabled && styles.text_disabled, inverse && styles.text_inverse, large && styles.text_large, light && styles.text_light, micro && styles.text_micro, mono && styles.text_mono, muted && styles.text_muted, nowrap && styles.text_nowrap, positive && styles.text_positive, primary && styles.text_primary, right && styles.text_right, secondary && styles.text_secondary, short && styles.text_short, small && styles.text_small, tall && styles.text_tall), loading ? /*#__PURE__*/_react.default.createElement(_Shimmer.default, {
      height: shimmerHeight || '1ex',
      width: shimmerWidth || '60%'
    }) : children);
  }

  return /*#__PURE__*/_react.default.createElement("p", (0, _withStyles.css)(styles.text, bold && styles.text_bold, center && styles.text_center, collapsed && styles.text_collapsed, disabled && styles.text_disabled, (error || negative) && styles.text_error, inverse && styles.text_inverse, large && styles.text_large, light && styles.text_light, micro && styles.text_micro, mono && styles.text_mono, muted && styles.text_muted, nowrap && styles.text_nowrap, positive && styles.text_positive, primary && styles.text_primary, right && styles.text_right, secondary && styles.text_secondary, short && styles.text_short, small && styles.text_small, tall && styles.text_tall, inline && styles.text_inline), loading ? /*#__PURE__*/_react.default.createElement(_Shimmer.default, {
    height: shimmerHeight || '1ex',
    width: shimmerWidth || '60%'
  }) : children);
};

Text.propTypes = propTypes;
const TextWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    units,
    color,
    weight,
    fontSize,
    lineHeight,
    font,
    breakpoint
  } = _ref2;
  return {
    text: {
      wordWrap: 'break-word',
      letterSpacing: 'normal',
      fontFamily: font.default,
      color: color.grayDarker,
      fontWeight: weight.normal,
      fontSize: fontSize.small.regular,
      lineHeight: lineHeight.regular,
      margin: 0,
      padding: 0,
      display: 'block',
      [breakpoint.large]: {
        fontSize: fontSize.large.regular
      }
    },
    text_bold: {
      fontWeight: weight.bold
    },
    text_collapsed: {
      whiteSpace: 'nowrap',
      overflow: 'hidden',
      textOverflow: 'ellipsis'
    },
    text_disabled: {
      opacity: .5
    },
    text_center: {
      textAlign: 'center'
    },
    text_right: {
      textAlign: 'right'
    },
    text_error: {
      color: color.alertDark
    },
    text_inverse: {
      color: color.white
    },
    text_large: {
      fontSize: fontSize.small.large,
      [breakpoint.large]: {
        fontSize: fontSize.large.large
      }
    },
    text_light: {
      fontWeight: weight.light
    },
    text_micro: {
      fontSize: fontSize.small.micro,
      [breakpoint.large]: {
        fontSize: fontSize.large.micro
      }
    },
    text_mono: {
      color: color.black
    },
    text_muted: {
      color: color.blueGrayDark
    },
    text_primary: {
      color: color.primary
    },
    text_secondary: {
      color: color.secondary
    },
    text_positive: {
      color: color.success
    },
    text_short: {
      lineHeight: lineHeight.short
    },
    text_tall: {
      lineHeight: lineHeight.tall
    },
    text_small: {
      fontSize: fontSize.small.small,
      [breakpoint.large]: {
        fontSize: fontSize.large.small
      }
    },
    text_inline: {
      display: 'inline-block'
    },
    text_nowrap: {
      whiteSpace: 'nowrap'
    }
  };
})(Text);
var _default = TextWithStyles;
exports.default = _default;