"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormElement = _interopRequireDefault(require("./FormElement"));

var _TextAreaOnly = _interopRequireDefault(require("./TextAreaOnly"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = {
  actionLink: _propTypes.default.string,
  compact: _propTypes.default.bool,
  borderless: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  errorMessage: _propTypes.default.any,
  extraPadding: _propTypes.default.bool,
  focusBorderless: _propTypes.default.bool,
  hideLabel: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  label: _propTypes.default.string,
  labelDescription: _propTypes.default.string,
  large: _propTypes.default.bool,
  lightLabel: _propTypes.default.bool,
  maxLength: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  minRows: _propTypes.default.number,
  name: _propTypes.default.string.isRequired,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  readOnly: _propTypes.default.bool,
  removeMargins: _propTypes.default.bool,
  showCount: _propTypes.default.bool,
  showFakeValuePlaceholder: _propTypes.default.bool,
  showOverflowEllipsis: _propTypes.default.bool,
  small: _propTypes.default.bool,
  value: _propTypes.default.string
};

const TextArea = _ref => {
  let {
    actionLink,
    compact,
    borderless,
    disabled,
    errorMessage,
    extraPadding,
    focusBorderless,
    hideLabel,
    id,
    inline,
    invalid,
    inverse,
    label,
    labelDescription,
    large,
    lightLabel,
    maxLength,
    minRows,
    name,
    onBlur,
    onChange,
    onFocus,
    placeholder,
    readOnly,
    removeMargins,
    showCount,
    showFakeValuePlaceholder,
    showOverflowEllipsis,
    small,
    value,
    refForFocus
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(_FormElement.default, {
    actionLink: actionLink,
    errorMessage: errorMessage,
    hideLabel: hideLabel,
    id: id,
    inline: inline,
    invalid: invalid,
    inverse: inverse,
    label: label,
    labelDescription: labelDescription,
    large: large,
    lightLabel: lightLabel,
    small: small
  }, /*#__PURE__*/_react.default.createElement(_TextAreaOnly.default, {
    refForFocus: refForFocus,
    borderless: borderless,
    compact: compact,
    disabled: disabled,
    extraPadding: extraPadding,
    focusBorderless: focusBorderless,
    id: id,
    inline: inline,
    invalid: invalid,
    inverse: inverse,
    large: large,
    maxLength: maxLength,
    minRows: minRows,
    name: name,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    placeholder: placeholder,
    readOnly: readOnly,
    removeMargins: removeMargins,
    showCount: showCount,
    showFakeValuePlaceholder: showFakeValuePlaceholder,
    showOverflowEllipsis: showOverflowEllipsis,
    small: small,
    value: value
  }));
};

TextArea.propTypes = propTypes;
var _default = TextArea;
exports.default = _default;