"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

var _reactWithStyles = require("react-with-styles");

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const propTypes = { ..._reactWithStyles.withStylesPropTypes,
  actionLink: _propTypes.default.string,
  compact: _propTypes.default.bool,
  borderless: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  focusBorderless: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  large: _propTypes.default.bool,
  maxLength: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  minRows: _propTypes.default.number,
  name: _propTypes.default.string.isRequired,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  readOnly: _propTypes.default.bool,
  removeMargins: _propTypes.default.bool,
  shimmer: _propTypes.default.bool,
  showCount: _propTypes.default.bool,
  showFakeValuePlaceholder: _propTypes.default.bool,
  showOverflowEllipsis: _propTypes.default.bool,
  small: _propTypes.default.bool,
  value: _propTypes.default.string
};
const defaultProps = {
  minRows: 4
};

const TextAreaOnly = _ref => {
  let {
    actionLink,
    compact,
    borderless,
    css,
    disabled,
    extraPadding,
    focusBorderless,
    id,
    inline,
    invalid,
    inverse,
    large,
    maxLength,
    minRows,
    name,
    onBlur,
    onChange,
    onFocus,
    placeholder,
    readOnly,
    removeMargins,
    shimmer,
    showCount,
    showFakeValuePlaceholder,
    showOverflowEllipsis,
    small,
    styles,
    value,
    refForFocus
  } = _ref;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.textAreaOnly, !inline && styles.block, borderless && styles.borderless, disabled && styles.textAreaOnly_disabled, invalid && styles.textAreaOnly_invalid, inverse && styles.textAreaOnly_inverse, small && styles.textAreaOnly_small, removeMargins && styles.textAreaOnly_noMargin), shimmer && /*#__PURE__*/_react.default.createElement("div", css(styles.shimmer), /*#__PURE__*/_react.default.createElement(_Shimmer.default, {
    width: "100%",
    height: "100%"
  })), /*#__PURE__*/_react.default.createElement("textarea", _extends({}, css(styles.textAreaOnly__input, extraPadding && styles.textAreaOnly__input_extraPadding, showOverflowEllipsis && styles.textAreaOnly__input_ellipsis, showFakeValuePlaceholder ? styles.textAreaOnly__input_fakeValuePlaceholder : styles.textAreaOnly__input_defaultPlaceholder), {
    ref: refForFocus,
    disabled: disabled,
    id: id,
    maxLength: maxLength,
    name: name,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    placeholder: placeholder,
    value: value,
    readOnly: readOnly,
    "aria-readonly": readOnly
  })));
};

TextAreaOnly.propTypes = propTypes;
TextAreaOnly.defaultProps = defaultProps;
const TextAreaOnlyWithStyles = (0, _withStyles.withStyles)(_ref2 => {
  let {
    input,
    color,
    units
  } = _ref2;
  return {
    textAreaOnly: { ...input.default,
      display: 'inline-flex',
      position: 'relative',
      zIndex: 0,
      flexWrap: 'nowrap',
      alignItems: 'center',
      ':focus-within': { ...input.focus
      }
    },
    textAreaOnly_inverse: {
      background: color.white
    },
    textAreaOnly_disabled: { ...input.disabled
    },
    textAreaOnly_invalid: { ...input.invalid
    },
    textAreaOnly_small: { ...input.small
    },
    textAreaOnly_noMargin: {
      marginTop: 0,
      marginRight: 0,
      marginBottom: 0,
      marginLeft: 0
    },
    textAreaOnly__input: { ...input.default,
      border: 0,
      margin: 0,
      background: color.transparent,
      width: '100%',
      minHeight: units(2.5),
      maxHeight: units(10),
      paddingTop: input.verticalPadding,
      paddingRight: input.horizontalPadding,
      paddingBottom: input.verticalPadding,
      paddingLeft: input.horizontalPadding,
      boxSizing: 'border-box',
      '::-ms-clear': {
        display: 'none'
      },
      ':focus': {
        outline: 'none',
        boxShadow: 'none',
        border: 0
      }
    },
    textAreaOnly__input_extraPadding: {},
    textAreaOnly__input_ellipsis: {
      textOverflow: 'ellipsis'
    },
    textAreaOnly__input_defaultPlaceholder: {
      '::placeholder': {
        color: input.placeholderColor,
        opacity: 1
      }
    },
    textAreaOnly__input_fakeValuePlaceholder: {
      '::placeholder': {
        color: input.color,
        opacity: 1
      }
    },
    textAreaOnly__input_inversePlaceholder: {
      '::placeholder': {
        color: color.white,
        opacity: 1
      }
    },
    block: {
      display: 'flex',
      width: '100%'
    },
    borderless: {
      borderColor: input.background
    },
    shimmer: {
      position: 'absolute',
      width: '100%',
      height: '100%',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    }
  };
})(TextAreaOnly);
var _default = TextAreaOnlyWithStyles;
exports.default = _default;