"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const propTypes = {
  children: _propTypes.default.object.isRequired,
  debounceTimeoutMs: _propTypes.default.number,
  debouncedOnChange: _propTypes.default.func,
  throttleTimeoutMs: _propTypes.default.number,
  throttledOnChange: _propTypes.default.func
};

class ThrottledTextInput extends _react.Component {
  constructor(props) {
    super(props);
    this.onChange = this.onChange.bind(this);
    this.debouncedOnChange = _lodash.default.debounce(this.debouncedOnChange.bind(this), props.debounceTimeoutMs);
    this.throttledOnChange = _lodash.default.throttle(this.throttledOnChange.bind(this), props.throttleTimeoutMs);
  }

  debouncedOnChange(value) {
    this.props.debouncedOnChange(value);
  }

  throttledOnChange(value) {
    this.props.throttledOnChange(value);
  }

  onChange(event) {
    const {
      value
    } = event.target;
    const {
      debounceTimeoutMs,
      debouncedOnChange,
      throttleTimeoutMs,
      throttledOnChange
    } = this.props;

    if (debouncedOnChange && debounceTimeoutMs) {
      this.debouncedOnChange(value);
    } else if (throttledOnChange && throttleTimeoutMs) {
      this.throttledOnChange(value);
    }
  }

  render() {
    const {
      children
    } = this.props;
    return /*#__PURE__*/_react.default.cloneElement(_react.default.Children.only(children), {
      onChange: this.onChange
    });
  }

}

ThrottledTextInput.propTypes = propTypes;
var _default = ThrottledTextInput;
exports.default = _default;