"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Text = _interopRequireDefault(require("./Text"));

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

class Tooltip extends _react.Component {
  constructor(props) {
    super(props);
    this.state = {
      visible: false
    };
    this.hideTooltip = this.hideTooltip.bind(this);
    this.showTooltip = this.showTooltip.bind(this);
  }

  hideTooltip() {
    this.setState({
      visible: false
    });
  }

  showTooltip() {
    this.setState({
      visible: true
    });
  }

  render() {
    const {
      disabled,
      bottom,
      children,
      css,
      left,
      right,
      styles,
      text,
      top
    } = this.props;
    const {
      visible
    } = this.state;
    return /*#__PURE__*/_react.default.createElement("div", _extends({}, css(styles.tooltip), {
      onMouseLeave: !disabled && this.hideTooltip
    }), visible && /*#__PURE__*/_react.default.createElement("div", css(styles.tooltip__bubble, top && styles.tooltip_top, right && styles.tooltip_right, bottom && styles.tooltip_bottom, left && styles.tooltip_left), /*#__PURE__*/_react.default.createElement("div", css(styles.tooltip__message), typeof text === 'string' || typeof text === 'number' ? /*#__PURE__*/_react.default.createElement(_Text.default, {
      micro: true,
      center: true,
      inverse: true
    }, text) : /*#__PURE__*/_react.default.createElement(_react.Fragment, null, text))), /*#__PURE__*/_react.default.createElement("span", {
      onMouseOver: !disabled && this.showTooltip
    }, children));
  }

}

var _default = (0, _withStyles.withStyles)(_ref => {
  let {
    color,
    radius,
    units
  } = _ref;
  return {
    tooltip: {
      position: 'relative'
    },
    tooltip__bubble: {
      minWidth: 160,
      maxWidth: 240,
      position: 'absolute',
      zIndex: 10
    },
    tooltip_top: {
      bottom: '100%',
      left: '50%',
      paddingBottom: units(0.5),
      transform: 'translateX(-50%)'
    },
    tooltip_bottom: {
      top: '100%',
      left: '50%',
      paddingTop: units(0.5),
      transform: 'translateX(-50%)'
    },
    tooltip_left: {
      top: '50%',
      right: '100%',
      paddingRight: units(0.5),
      transform: 'translateY(-50%)'
    },
    tooltip_right: {
      top: '50%',
      left: '100%',
      paddingLeft: units(0.5),
      transform: 'translateY(-50%)'
    },
    tooltip__message: {
      background: color.grayDarker,
      borderRadius: radius,
      padding: units(0.25)
    }
  };
})(Tooltip);

exports.default = _default;