"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ConnectedTextArea = exports.ConnectedSelect = exports.ConnectedRadioButtonGroup = exports.ConnectedInput = exports.ConnectedCheckbox = void 0;

var _react = _interopRequireDefault(require("react"));

var _RadioButtonGroup = _interopRequireDefault(require("./RadioButtonGroup"));

var _Checkbox = _interopRequireDefault(require("./Checkbox"));

var _Input = _interopRequireDefault(require("./Input"));

var _TextArea = _interopRequireDefault(require("./TextArea"));

var _Select = _interopRequireDefault(require("./Select"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const ConnectedRadioButtonGroup = _ref => {
  let {
    input,
    data,
    valueField,
    textField,
    children,
    meta: {
      touched,
      error,
      warning
    },
    ...props
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(_RadioButtonGroup.default, _extends({}, input, props, {
    onChange: input.onChange,
    invalid: touched && (error != null || warning != null),
    errorMessage: error || warning
  }), children);
};

exports.ConnectedRadioButtonGroup = ConnectedRadioButtonGroup;

const ConnectedCheckbox = _ref2 => {
  let {
    input,
    data,
    valueField,
    textField,
    children,
    meta: {
      touched,
      error,
      warning
    },
    ...props
  } = _ref2;
  return /*#__PURE__*/_react.default.createElement(_Checkbox.default, _extends({}, input, props, {
    value: input.checked,
    onChange: input.onChange,
    invalid: touched && (error != null || warning != null),
    checked: input.value !== false && input.value !== ''
  }), children);
};

exports.ConnectedCheckbox = ConnectedCheckbox;

const ConnectedInput = _ref3 => {
  let {
    input,
    data,
    valueField,
    textField,
    meta: {
      touched,
      error,
      warning
    },
    ...props
  } = _ref3;
  return /*#__PURE__*/_react.default.createElement(_Input.default, _extends({}, input, props, {
    onChange: input.onChange,
    invalid: touched && (error != null || warning != null),
    errorMessage: error || warning
  }));
};

exports.ConnectedInput = ConnectedInput;

const ConnectedTextArea = _ref4 => {
  let {
    input,
    data,
    valueField,
    textField,
    meta: {
      touched,
      error,
      warning
    },
    ...props
  } = _ref4;
  return /*#__PURE__*/_react.default.createElement(_TextArea.default, _extends({}, input, props, {
    onChange: input.onChange,
    invalid: touched && (error != null || warning != null),
    errorMessage: error || warning
  }));
};

exports.ConnectedTextArea = ConnectedTextArea;

const ConnectedSelect = _ref5 => {
  let {
    input,
    data,
    valueField,
    textField,
    meta: {
      touched,
      error,
      warning
    },
    ...props
  } = _ref5;
  return /*#__PURE__*/_react.default.createElement(_Select.default, _extends({}, input, props, {
    onChange: input.onChange,
    onBlur: () => input.onBlur(input.value),
    invalid: touched && (error != null || warning != null),
    errorMessage: error || warning
  }));
};

exports.ConnectedSelect = ConnectedSelect;