"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cel = cel;
exports.tel = exports.date = exports.currency = exports.cpf = exports.cep = void 0;

var _createNumberMask = _interopRequireDefault(require("text-mask-addons/dist/createNumberMask"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function cel(userInput) {
  let numbers = userInput.match(/\d/g);
  let numberLength = 0;

  if (numbers) {
    numberLength = numbers.join("").length;
  }

  if (numberLength > 10) {
    return ['(', /[1-9]/, /[1-9]/, ')', ' ', /\d/, /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];
  } else {
    return ['(', /[1-9]/, /[1-9]/, ')', ' ', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];
  }
}

const tel = () => ['(', /[1-9]/, /[1-9]/, ')', ' ', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];

exports.tel = tel;

const date = () => [/\d/, /\d/, '/', /\d/, /\d/, '/', /\d/, /\d/, /\d/, /\d/];

exports.date = date;

const cpf = () => [/\d/, /\d/, /\d/, '.', /\d/, /\d/, /\d/, '.', /\d/, /\d/, /\d/, '-', /\d/, /\d/];

exports.cpf = cpf;

const cep = () => [/\d/, /\d/, '.', /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/];

exports.cep = cep;
const currency = (0, _createNumberMask.default)({
  prefix: 'R$ ',
  allowDecimal: true,
  thousandsSeparatorSymbol: '.',
  decimalSymbol: ','
});
exports.currency = currency;